c
c        CONNECTIVITY ANALISYS                   30.01.2004
c
         parameter(maxobl=10000,
     *             maxref=5000,maxsym=48,maxbou=20,maxmax=1000,
     *             lbuf=320000)
c
         character fnamsf*12,modprn*5,cdstep*4,fnams*12,fprot*12
         character fprot2*12,modmes*5,modovr*5
         character*12 gdfil(maxmax)
         character modrad*6
         dimension ro(lbuf)
         integer*2 numob3(lbuf)
         dimension kpoint(maxobl),nlet(maxobl),kpoipr(maxobl)
         dimension ih(maxref),ik(maxref),il(maxref),ss(maxref)
         dimension f(maxref),phi(maxref),fom(maxref)
         dimension symmat(12,maxsym)
         dimension nwork(201),cum(201)
         dimension cutof1(maxbou),cutof2(maxbou)
         dimension kobl(maxbou)
         dimension kma(10,maxbou),kmi(maxbou)
         dimension mult(10,maxbou),nmb(100)
         integer*2 ibuf1(lbuf),ibuf2(lbuf),ibuf3(lbuf)
         integer*2 ibuf4(lbuf),ibuf5(lbuf),ibuf6(lbuf)
         integer*1 iro(lbuf)
         logical l1,islist,pharad,phadef
c
         nudat=7
         nusf=9
         nuspr=11
         nunams=13
         nuprot=10
         nuprt2=12
         nout=14
         numes=nuprot
         kp201=201
         nmax=5
         pi=3.1415927
         kgdfil=0
c
          call rddat(nudat,nout,cdstep,fnams,
     *         ngroup,acell,bcell,ccell,alfa,beta,gamma,
     *         dmin,dmax,ncf,ncphi,ncfom,modovr,
     *         maxbou,cutof1,cutof2,nbound,
     *         nx,ny,nz,modprn,modmes,nbgood,mlgood,modrad)
          call coeff(acell,bcell,ccell,alfa,beta,gamma,
     *         ar11,ar12,ar13,ar22,ar23,ar33,
     *         a11,a12,a13,a22,a23,a33,vol)
          call rdspr(nuspr,nuprot,ngroup,maxsym,nsym,symmat)
c
          call defnm1(cdstep,lcdstp,fprot2,nuprt2)
          call prprot(nuprt2,fnams,modmes,
     *         ngroup,acell,bcell,ccell,alfa,beta,gamma,
     *         dmin,dmax,ncf,ncphi,ncfom,modovr,
     *         maxbou,cutof1,cutof2,nbound,
     *         nx,ny,nz,nall,lbuf,modprn,nbgood,mlgood,
     *         modrad)
cccccccccccccccccccccccccccccccccccccccccc
c        try to work with one .UF-file
c        if not - with list of file's names
cccccccccccccccccccccccccccccccccccccccccc
          open (nusf,file=fnams)
          read (nusf,'(a72)',end=3333,err=3333) title
          read (nusf,'(a72)',end=3333,err=3333) title
          read (nusf,'(i4)',end=3333,err=3333) lrec
          islist=.false.
          close(nusf)
          fnamsf=fnams
          goto 2222
3333      continue
          islist=.true.
          close(nusf)
c
          open (nunams,file=fnams)
          kgdfil=0
1111      continue
          read (nunams,'(a12)',end=9999) fnamsf
2222      continue
          write(*,'(a12)') fnamsf
          if (modmes.eq.'PRINT')
     *        call defnm2(cdstep,lcdstp,fnamsf,fprot,nuprot)
c
          call rdsf(nusf,nuprot,modmes,fnamsf,dmin,dmax,
     *        ar11,ar12,ar13,ar22,ar23,ar33,
     *        maxref,ncf,f,ncphi,phi,ncfom,fom,
     *        kref,ih,ik,il,ss)
          call intpha(kref,phi,pharad,phadef)
          if (.not.phadef) then
              write(nuprot,'(1x,a49/1x,a24)')
     *        'It is impossible to interpretate the input phases',
     *        ' (in degrees or radians)'
              stop'It is impossible to interpretate the input phases'
          end if
          if(pharad) then
             write(nuprt2,'(1x,a36)')
     *        'Phases are interpreted in RADIANS!!!'
            else
             write(nuprt2,'(1x,a36)')
     *        'Phases are interpreted in DEGREES!!!'
          end if
          do i=1,kref
             if (.not.pharad) phi(i)=phi(i)*pi/180.
             f(i)=f(i)*fom(i)
             if (modovr.eq.'OVRT ') f(i)=-f(i)
          end do
c
          call FFT1(nsym,symmat,kref,ih,ik,il,f,phi,nx,ny,nz,
     *                ro,numes)
          call gtmima(ro,nall,romin,romax,rms)
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a22,3g12.4)')
     *     'romin, romax, r.m.s.= ',romin,romax,rms
          call getcum(roav,sigma,
     *        ro,nall,romin,romax,kp201,nwork,cum)
c
         write(nuprt2,'(/1x,a12,a12)')'RESULTS for ',fnamsf
         if(modrad.eq.'CALC') then
         write(nuprt2,'(1x,a63,a5)')
     *'---------------------------------------------------------------',
     *'-----'
            write(nuprt2,'(a38,a30)')
     *' # ! cutoffs !   xc  !   yc  !   zc  !',
     *'   rad ! rmx/r ! rmn/r !cross?'
         write(nuprt2,'(1x,a63,a5)')
     *'---------------------------------------------------------------',
     *'-----'
          end if
          do nbou=1,nbound
          coff1=cutof1(nbou)
          coff2=cutof2(nbou)
          call gtrocr(coff1,rocri1,cum,romin,romax,kp201)
          call gtrocr(coff2,rocri2,cum,romin,romax,kp201)
          call sviaz2(nuprot,ro,nx,ny,nz,rocri1,rocri2,nobl,numob3,
     *                  lbuf,ibuf1,ibuf2,ibuf3,ibuf4,ibuf5,ibuf6,
     *                  maxobl,kpoint)
            if (modmes.eq.'PRINT')
     *         write(nuprot,'(/1x,a8,f6.3,a1,f6.3,a10,2g12.4)')
     *        'cutoff: ',coff1,'-',coff2,', rocrit: ',rocri1,rocri2
            call fin1(nuprot,modmes,nall,nbou,nobl,kpoint,
     *                kpoipr,nlet,kobl,nbound,
     *                kma,kmi,mult,nmax,nmb)
            if (modprn.eq.'PRINT') call prres(nout,nx,ny,nz,
     *          ro,iro,numob3,nlet,nobl,rocrit,coff1,coff2)
            if (modrad.eq.'CALC') call clcrad(nuprt2,nx,ny,nz,numob3,
     *         nmb,mult,nbound,nbou,coff1,coff2,rad,
     *         a11,a12,a13,a22,a23,a33)
          end do
          if (modmes.eq.'PRINT') call fin2(nuprot,
     *                kobl,nbound,cutof1,cutof2,
     *                kma,kmi,mult,nmax)
          call fin2(nuprt2,kobl,nbound,cutof1,cutof2,
     *                kma,kmi,mult,nmax)
         l1=.true.
         do i=1,nbgood
            l1=l1.and.mult(1,i).eq.mlgood.and.mult(2,i).eq.0
         end do
         if (l1) then
           kgdfil=kgdfil+1
           if(kgdfil.le.maxmax) gdfil(kgdfil)=fnamsf
         end if
c
         if(islist) goto 1111
9999     continue
         if (kgdfil.ne.0) then
            write(nuprt2,'(/a12,i2,a20,i2,a18)')
     *      ' Files with ',mlgood,' equal areas in the ',nbgood,
     *      ' first boundaries:'
            do i=1,kgdfil
               write(nuprt2,'(a12)') gdfil(i)
            end do
         end if
         stop
         end
c
         subroutine prres(nout,nx,ny,nz,ro,iro,numob3,
     *              nlet,nobl,rocrit,coff1,coff2)
         character abc*62,str*32,txt*32,buf*32
         dimension ro(nx,ny,nz),nlet(nobl)
         integer*1 iro(nx,ny)
         integer*2 numob3(nx,ny,nz)
c
         abc=
     * '.123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'
c
         write (nout,'(1x,a8,2f6.4)') 'cutoff: ',coff1,coff2
         do k=1,nz
         write (nout,'(1x,a2,i4)') 'z=',k
c
         do j=1,ny
         do i=1,nx
            if(ro(i,j,k).ge.rocrit) then
               iro(i,j)=1
               kall=kall+1
              else
               iro(i,j)=0
            end if
         end do
         end do
c
         do j=1,ny
           do i=1,32
              str(i:i)=' '
           end do
           do i=1,nx
              nn=numob3(i,j,k)
              if (nn.ne.0) then
                  nl=mod(nlet(nn),61)+2
                 else
                  nl=1
              end if
              str(i:i)=abc(nl:nl)
           end do
           write (txt,'(32i1)')(iro(ii,j),ii=1,nx)
           read(txt,'(a32)') buf
           write (nout,'(a32,2x,a32)') buf,str
         end do
         end do
         return
         end
         subroutine rddat(nudat,nout,cdstep,fnams,
     *         ngroup,acell,bcell,ccell,alfa,beta,gamma,
     *         dmin,dmax,ncf,ncphi,ncfom,modovr,
     *         maxbou,cutof1,cutof2,nbound,
     *         nx,ny,nz,modprn,modmes,nbgood,mlgood,modrad)
         character fnams*12,inps*72,modprn*5,fout*72,cdstep*4
         character modmes*5,modovr*5,modrad*6
         dimension cutof1(maxbou),cutof2(maxbou)
c
          nu2=20
          open(nudat,file='conan.dat')
          open(nu2,status='scratch')
10        continue
          read (nudat,'(a72)',end=20) inps
          if (inps(1:1).ne.'!') write (nu2,'(a72)') inps
          goto 10
20        continue
          close(nudat)
          rewind(nu2)
          nudat=nu2
c
          read (nudat,'(a4)',end=100) cdstep
          read (nudat,'(a12)',end=100) fnams
          read (nudat,'(a5)') modmes
          if (modmes.eq.'print') modmes='PRINT'
          if (modmes.eq.'noprt') modmes='NOPRT'
          read (nudat,*,end=100) ngroup
          read (nudat,*,end=100) acell,bcell,ccell,alfa,beta,gamma
          read (nudat,*,end=100) dmin, dmax
          read (nudat,*,end=100) ncf,ncfom,ncphi
          read (nudat,'(a5)',end=100) modovr
          if (modovr.eq.'ovrt ') modovr='OVRT '
          if (modovr.eq.'novrt') modovr='NOVRT'
          read (nudat,*,end=100) nx,ny,nz
          read (nudat,'(a5)') modprn
          if (modprn.eq.'print') modprn='PRINT'
          if (modprn.eq.'noprt') modprn='NOPRT'
          if (modprn.eq.'PRINT') then
             fout='conan.www'
             open(nout,file=fout)
          end if
          read (nudat,*,end=100) nbound
          do i=1,nbound
            read (nudat,*,end=100) cutof1(i),cutof2(i)
          end do
          read (nudat,*,end=100) nbgood
          read (nudat,*,end=100) mlgood
          read (nudat,'(a6)',end=100) modrad
          if (modrad.eq.'calc') modrad='CALC'
          if (modrad.eq.'nocalc') modrad='NOCALC'
         return
100      continue
         stop 'Invalid input data'
         end
         subroutine prprot(nuprot,fnams,modmes,
     *         ngroup,acell,bcell,ccell,alfa,beta,gamma,
     *         dmin,dmax,ncf,ncphi,ncfom,modovr,
     *         maxbou,cutof1,cutof2,nbound,
     *         nx,ny,nz,nall,lbuf,modprn,nbgood,mlgood,
     *         modrad)
         character fnams*12,modprn*5,modmes*5,modovr*5,modrad*6
         dimension cutof1(maxbou),cutof2(maxbou)
c
          write (nuprot,'(/1x,a25,a12)')
     *     'File with list of names: ',fnams
          write (nuprot,'(1x,a35,a5)')
     *     'Print mode for each messages file: ',modmes
          write (nuprot,'(1x,a20,i4)')'Space group number: ',ngroup
          write (nuprot,'(1x,a10,3f8.2,3f4.0)') 'Unit cell:',
     *           acell,bcell,ccell,alfa,beta,gamma
          write (nuprot,'(1x,a19,2f10.2)')'Resolution limits: ',
     *           dmin,dmax
          write (nuprot,'(1x,a17,3i4)')'Columns numbers: ',
     *           ncf,ncfom,ncphi
          write(nuprot,'(1x,a10,3i5)')'nx,ny,nz: ',nx,ny,nz
          write (nuprot,'(1x,a18,a5)')
     *     'Overturning mode: ',modovr
          if (modovr.ne.'OVRT '.and.modovr.ne.'NOVRT') then
            write (nuprot,'(1x,a24)') 'Invalid overturning mode'
            stop 'Invalid overturning mode'
          end if
          write (nuprot,'(1x,a43,a5)')
     *     'Print mode for connectivity areas numbers: ',modprn
          if (modprn.ne.'PRINT'.and.modprn.ne.'NOPRT') then
            write (nuprot,'(1x,a18)') 'Invalid print mode'
            stop 'Invalid print mode'
          end if
          if (modprn.eq.'PRINT'.and.nx.gt.32) then
             write (nuprot,'(1x,a23)') 'Due to mode PRINT nx=32'
             nx=32
             write(nuprot,'(a10,3i5)')'nx,ny,nz: ',nx,ny,nz
          end if
          nall=nx*ny*nz
          if (nall.gt.lbuf) then
              write(nuprot,'(a6,i8,a6,i8)')' nall=',nall,',lbuf=',lbuf
              write (nuprot,'(1x,a22)') 'LBUF is too small!!!'
              stop 'LBUF is too small!!!'
          end if
          write(nuprot,'(1x,a22,i2)')'Number of boundaries: ',nbound
          if (nbound.gt.maxbou) then
              write (nuprot,'(1x,a19)') 'NBOUND is too large'
              stop 'NBOUND is too large'
          end if
          do i=1,nbound
            write(nuprot,'(a10,2f6.3)')' Cut-off: ',cutof1(i),cutof2(i)
          end do
          write(nuprot,'(1x,a36,i2)')
     *     'Number of boundaries for good file: ',nbgood
          write(nuprot,'(1x,a29,i2)')
     *     'Multiplicator for good file: ',mlgood
          write(nuprot,'(1x,a41,a6)')
     *     'Mode for calculation of inertion radius: ',modrad
          if (modrad.ne.'CALC'.and.modrad.ne.'NOCALC') then
            write (nuprot,'(1x,a24)') 'Invalid calculation mode'
            stop 'Invalid calculation mode'
          end if
         return
         end
      SUBROUTINE coeff(a,b,c,alfa,beta,gamma,
     *                 ar11,ar12,ar13,ar22,ar23,ar33,
     *                 a11,a12,a13,a22,a23,a33,vol)
c
c  coefficients of reciprocal space metric tenzor:ar11,...,ar33
c  coefficients of direct space metric tenzor:a11,...,a33
c  coefficients to transform absolute coordinates into
c               relative ones: p1, ..., p6
c
          pi=3.1415926
          arad=alfa*pi/180.
          brad=beta*pi/180.
          grad=gamma*pi/180.
          ca=cos(arad)
          cb=cos(brad)
          cg=cos(grad)
          sa=sin(arad)
          sb=sin(brad)
          sg=sin(grad)
          w=sqrt(1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg)
          cappa=1-ca*ca-cb*cb-cg*cg+2*ca*cb*cg
          ww=a*b*c*cappa
          if (ww.eq.0) stop 'Wrong unit cell parameters'
          vol=a*b*c*w
          p1=1./a
          p2=-cg/(a*sg)
          p3=(ca*cg-cb)/(a*w*sg)
          p4=1./(b*sg)
          p5=(cb*cg-ca)/(b*w*sg)
          p6=sg/(c*w)
          ar11=sa*sa/(a*a*cappa)
          ar12=(ca*cb-cg)/(a*b*cappa)
          ar13=(ca*cg-cb)/(a*c*cappa)
          ar22=(sb*sb)/(b*b*cappa)
          ar23=(cb*cg-ca)/(b*c*cappa)
          ar33=(sg*sg)/(c*c*cappa)
          a11=a*a
          a22=b*b
          a33=c*c
          a12=a*b*cg
          a13=a*c*cb
          a23=b*c*ca
      RETURN
      END
      SUBROUTINE rdspr(nuspr,nuprot,ngroup,maxsym,nsym,symmat)
c       input of 'crystallographic tables' file
        character fnspr*80,txt*8
        dimension symmat(12,maxsym)
c
        fnspr='fam.itc'
        open(nuspr,file=fnspr)
c
10      continue
        read (nuspr,'(a8)',end=100) txt
        if (txt.ne.'NEWGROUP') goto 10
        read (nuspr,*,end=100) ngr
        if (ngr.ne.ngroup) goto 10
c
20      continue
        read (nuspr,*,end=200,err=200) nsym
        IF (nsym.gt.maxsym) THEN
            write(nuprot,'(1x,a44,i6)')
     *      '!!! Number of symmetries more then MAXSYM - ',nsym
            stop 'Number of symmetries is too large'
        END IF
        DO j=1,nsym
           read (nuspr,*,end=200,err=200) (symmat(i,j),i=1,12)
        END DO
        close(nuspr)
      RETURN
100     continue
        write (nuprot,'(1x,a47)')
     *  'There is no such group in the reference file - ',ngroup
        stop 'There is no necessary group in the reference file'
200     continue
        write(nuprot,'(1x,a36)')'Invalid format of the reference file'
        stop 'Invalid format of the reference file'
      END
      SUBROUTINE rdsf(nusf,nuprot,modmes,fnamsf,dmin,dmax,
     *        ar11,ar12,ar13,ar22,ar23,ar33,
     *        maxref,ncf,f,ncphi,phi,ncfom,fom,
     *        kref,ih,ik,il,ss)
c     input of structure factors
      character fnamsf*12,title*72,modmes*5
      dimension w(100)
      dimension ih(maxref),ik(maxref),il(maxref),ss(maxref)
      dimension phi(maxref),f(maxref),fom(maxref)
      logical more
c
          open (nusf,file=fnamsf)
          read (nusf,'(a72)') title
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a72)') title
          read (nusf,'(a72)') title
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a72)') title
c
      more=.false.
      kref=0
      dd=1.e10
      ssmin=1./(dmax*dmax)
      ssmax=1./(dmin*dmin)
      read (nusf,'(i4)') lrec
      if (lrec.gt.103) then
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a38,i4)')
     *          'Too long record in file of reflexes - ',lrec
         stop 'Too long record in file of reflexes'
      end if
      if (ncf.gt.lrec) then
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a35)')
     *          'Incorrect column number for modules'
         stop 'Incorrect column number for modules'
      end if
      if (ncfom.gt.lrec) then
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a35)')
     *          'Incorrect column number for weights'
         stop 'Incorrect column number for weights'
      end if
      if (ncphi.gt.lrec) then
          if (modmes.eq.'PRINT') write (nuprot,'(1x,a34)')
     *          'Incorrect column number for phases'
         stop 'Incorrect column number for phases'
      end if
      kw=lrec-3
5     continue
      IF (kw.eq.0) THEN
         read (nusf,1000,end=110) iih,iik,iil
        ELSEIF (kw.le.5) THEN
         read (nusf,1000,end=110) iih,iik,iil,(w(i),i=1,kw)
        ELSEIF (kw.gt.5) THEN
         read (nusf,1010,end=110) iih,iik,iil,(w(i),i=1,kw)
      END IF
1000  format(3i4,5g12.6)
1010  format(3i4,5g12.6/(6g12.6))
      s21=ar11*iih*iih+ar22*iik*iik+ar33*iil*iil
      s22=2*ar12*iih*iik+2*ar13*iih*iil+2*ar23*iik*iil
      s2=s21+s22
      if (s2.lt.ssmin.or.s2.gt.ssmax) goto 5
      if (ncf.ne.0.and.w(ncf-3).eq.dd) goto 5
      if (ncfom.ne.0.and.w(ncfom-3).eq.dd) goto 5
      if (ncphi.ne.0.and.w(ncphi-3).eq.dd) goto 5
c
      kref=kref+1
      if (kref.gt.maxref.and..not.more) more=.true.
      IF (kref.gt.maxref) goto 5
          ih(kref)=iih
          ik(kref)=iik
          il(kref)=iil
          ss(kref)=s2
          f(kref)=w(ncf-3)
          if(ncfom.ne.0) then
             fom(kref)=w(ncfom-3)
            else
             fom(kref)=1.
          end if
          phi(kref)=w(ncphi-3)
      goto 5
110   continue
      if (modmes.eq.'PRINT') then
      IF (.not.more) THEN
         write(nuprot,'(3x,i6,a25)') kref,' reflections are selected'
        else
         write(nuprot,'(3x,i6,a59,i6)') kref,
     *   ' reflections are sutaible, but dimension of arrays is only ',
     *   maxref
      END IF
      end if
         IF (more) THEN
             if (modmes.eq.'PRINT')
     *             write (nuprot,'(/1x,a5/1x,a24/1x,a5)') '*****',
     *             'MAXREF is not enough !!!','*****'
             stop 'MAXREF is not enough'
         END IF
      RETURN
      END
      SUBROUTINE gtmima(ro3,nall,romin,romax,rms)
      dimension ro3(nall)
c
      romin=ro3(1)
      romax=ro3(1)
      s=0
      do i=1,nall
         if (ro3(i).gt.romax) romax=ro3(i)
         if (ro3(i).lt.romin) romin=ro3(i)
         s=s+ro3(i)*ro3(i)
      end do
      rms=sqrt(s/nall)
      RETURN
      END
      SUBROUTINE getcum(roav,sigma,
     *        ro3,nall,romin,romax,kpoint,nwork,cum)
c     input of electron-density from temporary file
          dimension ro3(nall)
          dimension nwork(kpoint),cum(kpoint)
          real*8 sumro,sumro2,sumww,ww
c
          sumro=0.
          sumro2=0.
          sumww=0.
          roav2=0.
          coef=0.
          if (romax.ne.romin) then
            step1=(kpoint-1.)/(romax-romin)
           else
            step1=0.
          end if
          DO i=1,kpoint
             nwork(i)=0
          END DO
c
          nww=1
          ww=1.
          DO i=1,nall
                   rro=ro3(i)
                   sumww=sumww+ww
                   sumro=sumro+rro*ww
                   sumro2=sumro2+rro*rro*ww
                   k=(rro-romin)*step1+1.
                   if (k.lt.1) k=1
                   if (k.gt.kpoint) k=kpoint
                   nwork(k)=nwork(k)+nww
          END DO
c          write (nuprot,'(a6)') 'nwork:'
c          write (nuprot,*) (nwork(i),i=1,kpoint)
          roav=0.
          if (sumww.ne.0.) roav=sumro/sumww
          if (sumww.ne.0.) roav2=sumro2/sumww
          sigma=sqrt(roav2-roav*roav)
          if (sumww.ne.0.) coef=1./sumww
c
          DO i=2,kpoint
             nwork(i)=nwork(i)+nwork(i-1)
          END DO
          DO i=2,kpoint
             cum(i)=nwork(i-1)*coef
          END DO
          cum(1)=0.
          cum(kpoint)=1.
      RETURN
      END
      SUBROUTINE gtrocr(bound,rocrit,cum,romin,romax,kpoint)
c     calculation of critical level value for mask function
          dimension cum(kpoint)
c
300       continue
             v=bound
310       continue
          step=(romax-romin)/(kpoint-1)
             c=1.-v
             if (c.lt.0.) c=0.
             if (c.gt.1.) c=1.
             nn=1
             DO WHILE (c.gt.cum(nn).and.nn.lt.kpoint)
                   nn=nn+1
             END DO
c
c            c(i).le.cum(nn).or.nn.eq.kpoint
c
             IF (c.eq.cum(nn).or.nn.eq.kpoint) THEN
                rocrit=romin+step*(nn-1)
               ELSE
                w=step*(c-cum(nn-1))/(cum(nn)-cum(nn-1))
                rocrit=romin+step*(nn-2)+w
             END IF
c
          RETURN
      END
c*********************************************************************
c** SFP1 **                                           18 September 1997
c**********                                           V.Yu.Lunin
c
c           Structure factors calculation for P1 space group
c
      SUBROUTINE SFP1(x,lbuf,nx,ny,nz,scale,nref,ih,ik,il,f,phi,mes)
      dimension x(lbuf)
      dimension ih(nref),ik(nref),il(nref),f(nref),phi(nref)
c
c        The program calculates inverse Fourier transform
C
C          F(H,K,L)=(SCALE/(NX*NY*NZ))*
C                                                   H*R K*S L*T
C                   * SUMMA  (RO(R,S,T)*EXP(2*PI*I*(---+---+---)) )
C                     R=0,NX-1                      NX  NY   NZ
C                     S=0,NY-1
C                     T=0,NZ-1
C
c        for specified set of indexes, supposing that
c        max!h!<=nx/2-1, max!k!<=ny/2-1, max!l!<nz/2-1
c
c          INPUT
c               It is supposed that the NX*NY*NZ array containing
c               electron density values is a part of a larger array;
c               the rest of this extended array will be used as
c               additional memory when calculating FFT;
c
c               x(.) - the extended electron density array;
c                      its first nx*ny*nz elements are considered
c                      as REAL nx*ny*nz array containing density
c                      values;
c                      !!! THESE VALUES WILL BE DESTROYED !!!
c               lbuf - real length of x-array; it  must be
c                      (nx+2)*ny*nz at least;
c                      !!! THE FIRST (nx+2)*ny*nz ELEMENTS OF x-ARRAY
c                          WILL BE DESTROYED IN THE SUBROUTINE !!!
c               nx,ny,nz - grid dimensions;
c               scale - scale factor;
c               nref  - number of structure factors be calculated;
c               ih(.),ik(.),il(.) - their indexes;
c               mes - file for messages;
c          OUTPUT
c               f(.),phi(.) - modules and phases of desired
c                      structure factors;
c               x(.) - when it's finished, the input values are replaced
c                      in this array for structure factors ones;
c                      thei array is considered as
c                      COMPLEX  (maxh+1)*ny*nz array;
c                      the value F(h,k,l) is in X(h+1,k+1,l+1)
C                      (assuming that  F(H,K,-L)=F(H,K,NZ-L),
C                                    F(H,-K,L)=F(H,NY-K,L)  )
c                      the only defined elements are ones with
c                      0<=h<=maxh, -maxk<=k<=maxk, -maxl<=l<=maxl.
C
c        ATTENTION !
c           - the real size of X-array must be (Nx+2)*Ny*Nz at least !
c           - Nx must be even;
c           - pay your attention to F-data placing in X-array
c             (especially for negative h and k indexes)
c
c    SUBROUTINES USED : SF1, SF1A, SF1B - are present in this batch;
c                       1-dimensional FFT kernel;
c.................................................
c
      twopi=6.283185
      maxh=iabs(ih(1))
      maxk=iabs(ik(1))
      maxl=iabs(il(1))
      do j=1,nref
        iw=iabs(ih(j))
        if(iw.gt.maxh) maxh=iw
        iw=iabs(ik(j))
        if(iw.gt.maxk) maxk=iw
        iw=iabs(il(j))
        if(iw.gt.maxl) maxl=iw
      enddo
c
      if(maxh.gt.nx/2-1 .or. maxk.gt.ny/2-1 .or. maxl.gt.nz/2-1) then
        write(mes,1000) nx,ny,nz,maxh,maxk,maxl
1000    format(1x,'** SFP1 ** RO-array dimensions :',3i5/
     *         12x,'are too small for max!indexes! :',3i5)
        STOP
      endif
      if((nx/2)*2.ne.nx) then
        write(mes,*)'** SFP1 **  NX must be even, NX=',nx
       STOP
      endif
      iw=(nx+2)*ny*nz
      if(iw.gt.lbuf) then
        write(mes,*)'** SFP1 ** Too small x-array; its length must be',
     *               iw
        STOP
      endif
c
      CALL SF1(x,nx,ny,nz,maxh,maxk,maxl,scale,lbuf)
c
      n1=2*(maxh+1)
      n2=n1*ny
      do j=1,nref
        jjh=ih(j)
        jh=jjh
        jk=ik(j)
        jl=il(j)
        if(jjh.lt.0) then
          jh=-jh
          jk=-jk
          jl=-jl
        endif
        if(jk.lt.0) jk=ny+jk
        if(jl.lt.0) jl=nz+jl
        ind=2*jh+jk*n1+jl*n2+1
c
        fre=x(ind)
        fim=x(ind+1)
        if(jjh.lt.0) fim=-fim
c
        fw=sqrt(fre*fre+fim*fim)
        pw=0.
        if(fw.ne.0.) pw=atan2(fim,fre)
        if(pw.lt.0) pw=pw+twopi
        f(j)=fw
        phi(j)=pw
      enddo
c
      RETURN
      END
c-----------------------------------------------------------
C      SF1                                           18.09.97
c                                                    V.Yu.Lunin
C
c        The program calculates inverse Fourier transform
C
C          F(H,K,L)=(SCALE/(NX*NY*NZ))*
C                                                   H*R K*S L*T
C                   * SUMMA  (RO(R,S,T)*EXP(2*PI*I*(---+---+---)) )
C                     R=0,NX-1                      NX  NY   NZ
C                     S=0,NY-1
C                     T=0,NZ-1
C
C        for  0<=H<=MAXH,-MAXK<=K<=MAXK,0<=L<=MAXL
C
c        INPUT DATA
c        X - containes RO(r,s,t) values; X-array is considered as
c            three-dimensional with dimensions Nx Ny Nz;
c            the value RO(r,s,t) is in X(r+1,s+1,t+1);
c        Nx,Ny,Nz - grid numbers (dimensions of RO-array);
c        maxh,maxk,maxl - define the set of necessary F-values;
C	 SCALE - scale-value;
c
c        OUTPUT DATA
c        X - containes calculated F(h,k,l)-values; it is considered
c            as three-dimensional array with dimensions
c            (maxh+1) Ny Nz; the value F(h,k,l) is in X(h+1,k+1,l+1)
C                    (assuming that  F(H,K,-L)=F(H,K,NZ-L),
C                                    F(H,-K,L)=F(H,NY-K,L)  )
c            the only defined elements are ones with
c            0<=h<=maxh, -maxk<=k<=maxk, -maxl<=l<=maxl.
C
c        ATTENTION !
c           - the real size of X-array must be (Nx+2)*Ny*Nz at least !
c           - must be
C                              2*MAXH+1<=NX
C                              2*MAXK+1<=NY
C                              2*MAXL+2<=NZ
C                              NX - even;
c           - the axes order : input data x y z ,
c                              ouput data h k l ;
c           - pay your attention to F-data placing in X-array
c             (especially for negative h and k indexes)
c
c        SUBROUTINES USED
c           One-dimensional Fast Fourier Transform package of
c           L.F.Ten Eyck;
c           SF1A, SF1B.
C
      SUBROUTINE SF1(X,NX,NY,NZ,MAXH,MAXK,MAXL,SCALE,nsize)
C
      DIMENSION X(nsize),K(5)
C
c   decompressing X-array; The first dimension will be Nx+2
c
      CALL SF1A(X,NX,NY,NZ,X,NX+2,NY,NZ)
C
      NTOT=(NX+2)*NY*NZ
      K(1)=NTOT
      K(2)=2
      K(3)=NTOT
      K(4)=NTOT
      K(5)=NX+2
      CALL REALFT(X(1),X(2),NX/2,K,nsize)
C
C          compressing  X - array;
C          the first dimension will be equal to  2*(MAXH+1)
C
      N3=2*(MAXH+1)
      CALL SF1B(X,NX+2,NY,NZ,  X,N3,NY,NZ)
C
C
C
      K(1)=2*(MAXH+1)*NY*NZ
      K(2)=2*(MAXH+1)
      K(3)=2*(MAXH+1)*NY
      K(4)=2*(MAXH+1)
      K(5)=2
      CALL CMPLFT(X(1),X(2),NY,K,nsize)
C
C
C
      K(1)=2*(MAXH+1)*NY*NZ
      K(2)=2*(MAXH+1)*NY
      K(3)=2*(MAXH+1)*NY*NZ
      K(4)=2*(MAXH+1)*(MAXK+1)
      K(5)=2
      CALL CMPLFT(X(1),X(2),NZ,K,nsize)
C
      K(4)=2*(MAXH+1)*MAXK
      JA=(NY-MAXK)*2*(MAXH+1)+1
      CALL CMPLFT(X(JA),X(JA+1),NZ,K,nsize)
C
C
C          scaling and transition to complex conjugate
C
      CONST=SCALE/(NX*NY*NZ)
      N1=2*(MAXH+1)*NY*(MAXL+1)
      W=-CONST
      DO 10 J=1,N1
      W=-W
      X(J)=W*X(J)
10    CONTINUE
C
      N2=2*(MAXH+1)*NY*(NZ-MAXL)+1
      N3=2*(MAXH+1)*NY*NZ
      W=-CONST
      DO 20 J=N2,N3
      W=-W
      X(J)=W*X(J)
20    CONTINUE
C
C
C
      RETURN
      END
c
c-----------------------------------------------------------
c
      SUBROUTINE SF1A(X,n1,n2,n3,Y,k1,k2,k3)
c
c	Decompressing X-array into Y-array;
c       must be n1<=k1, n2<=k2, n3<=k3
c
      dimension X(n1,n2,n3), Y(k1,k2,k3)
c
      do 50 i3=1,n3
        m3=n3-i3+1
        do 40 i2=1,n2
          m2=n2-i2+1
          do 30 i1=1,n1
            m1=n1-i1+1
            Y(m1,m2,m3)=X(m1,m2,m3)
30        continue
40      continue
50    continue
c
c
      return
      end
c
      SUBROUTINE SF1B(X,n1,n2,n3,Y,k1,k2,k3)
      dimension X(n1,n2,n3), Y(k1,k2,k3)
c
c      compressing array X into Y begining from the first element
c      must be n1>=k1, n2>=k2, n3>=k3
c
      do 50 i3=1,k3
        do 40 i2=1,k2
          do 30 i1=1,k1
            Y(i1,i2,i3)=X(i1,i2,i3)
30        continue
40      continue
50    continue
c
      return
      end
c********************************************************************
      SUBROUTINE zphnor(phase,mode)
c
c        for mode=1 reduce the phase to [0,2*PI) interval
c        for mode=2 treats phase as a phase difference and reduce
c                   it to [0,PI] range.
c
      pi=3.1415927
      twopi=2.*pi
c
      w=amod(phase,twopi)
      if(w.lt.0.) w=w+twopi
c
      if(mode.eq.2) then
        if(w.gt.pi) w=twopi-w
      endif
c
      phase=w
      RETURN
      END
c
c---------------------------------------------------------------------
         subroutine fin1(nuprot,modmes,nall,nbou,nobl,kpoint,
     *            kpoipr,nlet,kobl,nbound,kma,kmi,mult,nmax,nmb)
         character modmes*5
         dimension kpoint(nobl),nlet(nobl),kpoipr(nobl)
         dimension kobl(nbound)
         dimension kma(10,nbound),kmi(nbound)
         dimension mult(10,nbound),nmb(100)
         logical isequ
c
         kk=0
         do i=1,10
            kma(i,nbou)=0
            mult(i,nbou)=0
         end do
         kmi(nbou)=nall
         do i=1,nobl
            if (kpoint(i).ne.0) then
                kk=kk+1
                kpoipr(kk)=kpoint(i)
                nlet(i)=kk
cccccccccccccccccccccccccc
                isequ=.false.
                do jj=1,nmax
                   if (kpoint(i).eq.kma(jj,nbou)) then
                       mult(jj,nbou)=mult(jj,nbou)+1
                       nj=mult(jj,nbou)
                       if (jj.eq.1.and.nj.le.100) nmb(nj)=i
                       isequ=.true.
                   end if
                end do
                if(isequ) goto 10
cccccccccccccccccccccccccc
                do jj=1,nmax
                   nn=nmax-jj
                   if(kpoint(i).gt.kma(jj,nbou)) then
                      if (nn.gt.0) then
                      do kkk=1,nn
                         ll=nmax+1-kkk
                         kma(ll,nbou)=kma(ll-1,nbou)
                         mult(ll,nbou)=mult(ll-1,nbou)
                      end do
                      end if
                      kma(jj,nbou)=kpoint(i)
                      mult(jj,nbou)=1
                      if(jj.eq.1) nmb(1)=i
                      goto 10
                   end if
                end do
10          continue
            end if
         if(kpoint(i).lt.kmi(nbou).and.kpoint(i).ne.0)
     *     kmi(nbou)=kpoint(i)
         end do
         kobl(nbou)=kk
         if (modmes.eq.'PRINT') then
             write (nuprot,'(1x,i4,a22)')kk,' areas of connectivity'
             write (nuprot,'((1x,10i6))')(kpoipr(i),i=1,kk)
         end if
         return
         end
         subroutine fin2 (nuprot,kobl,nbound,cutof1,cutof2,
     *                kma,kmi,mult,nmax)
         dimension cutof1(nbound),cutof2(nbound),kobl(nbound)
         dimension kma(10,nbound),kmi(nbound)
         dimension mult(10,nbound)
c
         write(nuprot,'(1x,a63,a5)')
     *'---------------------------------------------------------------',
     *'-----'
         write(nuprot,'(1x,a25,a42)')' #! cutoffs !Nar!  max1  ',
     *   '!  max2  !  max3  !  max4  !  max5  ! min '
         write(nuprot,'(1x,a63,a5)')
     *'---------------------------------------------------------------',
     *'-----'
         do i=1,nbound
      write(nuprot,'(1x,i2,a1,f4.2,a1,f4.2,a1,i3,5(a1,i2,a1,i5),a1,i5)')
     *       i,'!',cutof1(i),'-',cutof2(i),'!',kobl(i),
     *       ('!',mult(j,i),'*',kma(j,i),j=1,nmax),'!',kmi(i)
         end do
         write(nuprot,'(1x,a63,a5)')
     *'---------------------------------------------------------------',
     *'-----'
         return
         end
         subroutine  defnm1(cdstep,lcdstp,fprot2,nuprt2)
         character cdstep*4,fprot2*12
c
          do j=1,4
             i=5-j
             if (cdstep(i:i).ne.' ') goto 33
          end do
          stop 'Invalid cod of step'
33        continue
          lcdstp=i
          fprot2(1:lcdstp)=cdstep
          fprot2(lcdstp+1:lcdstp+8)='_con.mes'
          open(nuprt2,file=fprot2)
          write (nuprt2,'(10x,a40)')
     *           'CONNECTIVITY ANALISYS         30.01.2004'
          return
          end
          subroutine defnm2(cdstep,lcdstp,fnamsf,fprot,nuprot)
          character cdstep*4, fnamsf*12, fprot*12
c
c         next name of file of structure factors
c
          fprot='            '
          do i=1,8
             if (fnamsf(i:i).eq.'_') goto 44
          end do
          i=0
44        continue
          l1=i
          do i=l1+1,8
             if (fnamsf(i:i).eq.'.') goto 55
          end do
55        continue
          l2=i
          l3=l2-l1+1
          fprot(1:lcdstp)=cdstep
          fprot(lcdstp+1:lcdstp+1)='_'
          l4=lcdstp+l3
          if(l4.gt.9) l4=9
          l5=lcdstp+l3-l4
          fprot(lcdstp+2:l4)=fnamsf(l1+1:l2-l5)
          fprot(l4+1:l4+3)='mes'
          open(nuprot,file=fprot)
          write(nuprot,'(1x,a29,a12)')
     *         'Structure factors file name: ',fnamsf
          return
          end
          subroutine clcrad(nuprot,nx,ny,nz,numob3,
     *               nmb,mult,nbound,nbou,coff1,coff2,rad,
     *         a11,a12,a13,a22,a23,a33)
          character txt*6
          dimension nmb(100),mult(10,nbound)
          integer*2 numob3(nx,ny,nz)
          logical bad
c
          nn=mult(1,nbou)
          if(nn.gt.100) nn=100
c
          do iii=1,nn
             num=nmb(iii)
             bad=.false.
             call testx(nx,ny,nz,numob3,num,bad)
             if(.not.bad) call testy(nx,ny,nz,numob3,num,bad)
             if(.not.bad) call testz(nx,ny,nz,numob3,num,bad)
             if(.not.bad) then
                call insrad(num,nx,ny,nz,numob3,rad,
     *               a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
                goto 100
c                else
c          call outrad(num,nx,ny,nz,numob3,rad,
c     *               a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
             end if
c          if(.not.bad) then
c              txt='inside'
c             else
c              txt='cross '
c          end if
c         write(nuprot,'(1x,i2,a1,f4.3,a1,3(f7.4,a1),f9.2,a1,f9.2,a1,
c     *          1x,a6)')
c     *     nbou,'!',bound(nbou),'!',xc,'!',yc,'!',zc,'!',rad,'!',rmax,
c     *      '!',txt
          end do
          call outrad(num,nx,ny,nz,numob3,rad,
     *               a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
100       continue
          if(.not.bad) then
              txt='inside'
             else
              txt='cross '
          end if
          if(rad.ne.0.) then
             rmxrad=rmax/rad
             rmnrad=rmin/rad
            else
             rmxrad=-1.
             rmnrad=-1.
          end if
          write(nuprot,'(1x,i2,a1,f4.2,a1,f4.2,a1,3(f7.4,a1),
     *     f7.2,a1,f7.2,a1,f7.2,a1,a6)')
     *    nbou,'!',coff1,'-',coff2,'!',xc,'!',yc,'!',zc,'!',
     *    rad,'!',rmxrad,'!',rmnrad,'!',txt
          return
          end
          subroutine insrad(num,nx,ny,nz,numob3,rad,
     *         a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
          integer*2 numob3(nx,ny,nz)
c
          sx=0.
          sy=0.
          sz=0.
          np=0
          do i=1,nx
          do j=1,ny
          do k=1,nz
             if(numob3(i,j,k).eq.num) then
                np=np+1
                x=(i-1.)/nx
                y=(j-1.)/ny
                z=(k-1.)/nz
                sx=sx+x
                sy=sy+y
                sz=sz+z
             end if
          end do
          end do
          end do
          xc=sx/np
          yc=sy/np
          zc=sz/np
c
          srr=0.
          rrmax=0.
          rrmin=1.e+10
          do i=1,nx
          do j=1,ny
          do k=1,nz
             if(numob3(i,j,k).eq.num) then
                x=(i-1.)/nx
                y=(j-1.)/ny
                z=(k-1.)/nz
                dx=x-xc
                dy=y-yc
                dz=z-zc
                dxx=dx*dx
                dyy=dy*dy
                dzz=dz*dz
                dxy=dx*dy
                dxz=dx*dz
                dyz=dy*dz
                rr=a11*dxx+a22*dyy+a33*dzz+a12*dxy+a13*dxz+a23*dyz
                if(rr.gt.rrmax) rrmax=rr
                if(rr.lt.rrmin) rrmin=rr
                srr=srr+rr
             end if
          end do
          end do
          end do
          rad=sqrt(srr/np)
          rmax=sqrt(rrmax)
          rmin=sqrt(rrmin)
          return
          end
          subroutine testx(nx,ny,nz,numob3,num,bad)
          integer*2 numob3(nx,ny,nz)
          logical bad
c
             bad=.false.
             do j=1,ny
             do k=1,nz
                if(numob3(1,j,k).eq.num) then
                   jb=j
                   if(j.gt.1) jb=j-1
                   je=j
                   if(j.lt.ny) je=j+1
                   kb=k
                   if(k.gt.1) kb=k-1
                   ke=k
                   if(k.lt.nz) ke=k+1
                   do jj=jb,je
                   do kk=kb,ke
                      bad=bad.or.numob3(nx,jj,kk).eq.num
                   end do
                   end do
                end if
             end do
             end do
          return
          end
          subroutine testy(nx,ny,nz,numob3,num,bad)
          integer*2 numob3(nx,ny,nz)
          logical bad
c
             bad=.false.
             do i=1,nx
             do k=1,nz
                if(numob3(i,1,k).eq.num) then
                   ib=i
                   if(i.gt.1) ib=i-1
                   ie=i
                   if(i.lt.nx) ie=i+1
                   kb=k
                   if(k.gt.1) kb=k-1
                   ke=k
                   if(k.lt.nz) ke=k+1
                   do ii=ib,ie
                   do kk=kb,ke
                      bad=bad.or.numob3(ii,ny,kk).eq.num
                   end do
                   end do
                end if
             end do
             end do
          return
          end
          subroutine testz(nx,ny,nz,numob3,num,bad)
          integer*2 numob3(nx,ny,nz)
          logical bad
c
             bad=.false.
             do i=1,nx
             do j=1,ny
                if(numob3(i,j,1).eq.num) then
                   ib=i
                   if(i.gt.1) ib=i-1
                   ie=i
                   if(i.lt.nx) ie=i+1
                   jb=j
                   if(j.gt.1) jb=j-1
                   je=j
                   if(j.lt.ny) je=j+1
                   do ii=ib,ie
                   do jj=jb,je
                      bad=bad.or.numob3(ii,jj,nz).eq.num
                   end do
                   end do
                end if
             end do
             end do
          return
          end
          subroutine outrad(num,nx,ny,nz,numob3,rad,
     *               a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
          integer*2 numob3(nx,ny,nz)
          logical isx,isy,isz,is3
c
          call tstx(nx,ny,nz,numob3,num,isx,npx)
          is3=isx
          if(is3) then
             call tsty(nx,ny,nz,numob3,num,isy,npy)
             is3=is3.and.isy
          end if
          if(is3) then
            call tstz(nx,ny,nz,numob3,num,isz,npz)
            is3=is3.and.isz
          end if
          if (is3) then
              call shift(npx,npy,npz,num,nx,ny,nz,numob3,rad,
     *         a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
             else
              xc=-1.
              yc=-1.
              zc=-1.
              rad=-1.
              rmax=-1.
              rmin=-1.
          end if
          return
          end
          subroutine shift(npx,npy,npz,num,nx,ny,nz,numob3,rad,
     *         a11,a12,a13,a22,a23,a33,xc,yc,zc,rmax,rmin)
          integer*2 numob3(nx,ny,nz)
c
          ishft=nx-npx
          jshft=ny-npy
          kshft=nz-npz
          xshft=1.*ishft/nx
          yshft=1.*jshft/ny
          zshft=1.*kshft/nz
c
          sx=0.
          sy=0.
          sz=0.
          np=0
          do i=1,nx
          do j=1,ny
          do k=1,nz
             if(numob3(i,j,k).eq.num) then
                np=np+1
cccccccccccccccccccccccccc
                i2=i+ishft
                if(i2.gt.nx) i2=i2-nx
                j2=j+jshft
                if(j2.gt.ny) j2=j2-ny
                k2=k+kshft
                if(k2.gt.nz) k2=k2-nz
cccccccccccccccccccccccccc
                x=(i2-1.)/nx
                y=(j2-1.)/ny
                z=(k2-1.)/nz
                sx=sx+x
                sy=sy+y
                sz=sz+z
             end if
          end do
          end do
          end do
          xc=sx/np
          yc=sy/np
          zc=sz/np
c
          srr=0.
          rrmax=0.
          rrmin=1.e+10
          do i=1,nx
          do j=1,ny
          do k=1,nz
             if(numob3(i,j,k).eq.num) then
cccccccccccccccccccccccccc
                i2=i+ishft
                if(i2.gt.nx) i2=i2-nx
                j2=j+jshft
                if(j2.gt.ny) j2=j2-ny
                k2=k+kshft
                if(k2.gt.nz) k2=k2-nz
cccccccccccccccccccccccccc
                x=(i2-1.)/nx
                y=(j2-1.)/ny
                z=(k2-1.)/nz
                dx=x-xc
                dy=y-yc
                dz=z-zc
                dxx=dx*dx
                dyy=dy*dy
                dzz=dz*dz
                dxy=dx*dy
                dxz=dx*dz
                dyz=dy*dz
                rr=a11*dxx+a22*dyy+a33*dzz+a12*dxy+a13*dxz+a23*dyz
                if(rr.gt.rrmax) rrmax=rr
                if(rr.lt.rrmin) rrmin=rr
                srr=srr+rr
             end if
          end do
          end do
          end do
          rad=sqrt(srr/np)
          rmax=sqrt(rrmax)
          rmin=sqrt(rrmin)
          xc=xc-xshft
          if(xc.lt.0.) xc=xc+1.
          yc=yc-yshft
          if(yc.lt.0.) yc=yc+1.
          zc=zc-zshft
          if(zc.lt.0.) zc=zc+1.
          return
          end
          subroutine tstx(nx,ny,nz,numob3,num,isx,npx)
          integer*2 numob3(nx,ny,nz)
          logical isx,good
c
          do i=1,nx
             good=.true.
             do j=1,ny
             do k=1,nz
                good=good.and.numob3(i,j,k).ne.num
                if(.not.good) goto 5
             end do
             end do
             if(good) goto 10
5         continue
          end do
          isx=.false.
          return
10        continue
          isx=.true.
          npx=i
          return
          end
          subroutine tsty(nx,ny,nz,numob3,num,isy,npy)
          integer*2 numob3(nx,ny,nz)
          logical isy,good
c
          do j=1,ny
             good=.true.
             do i=1,nx
             do k=1,nz
                good=good.and.numob3(i,j,k).ne.num
                if(.not.good) goto 5
             end do
             end do
             if(good) goto 10
5            continue
          end do
          isy=.false.
          return
10        continue
          isy=.true.
          npy=j
          return
          end
          subroutine tstz(nx,ny,nz,numob3,num,isz,npz)
          integer*2 numob3(nx,ny,nz)
          logical isz,good
c
          do k=1,nz
             good=.true.
             do i=1,nx
             do j=1,ny
                good=good.and.numob3(i,j,k).ne.num
                if(.not.good) goto 5
             end do
             end do
5            continue
             if(good) goto 10
          end do
          isz=.false.
          return
10        continue
          isz=.true.
          npz=k
          return
          end
      SUBROUTINE sviaz2(nuprot,ro,nx,ny,nz,rocri1,rocri2,numreg,numob,
     *                    lbuf,ibuf1,ibuf2,ibuf3,ibuf4,ibuf5,ibuf6,
     *                    maxobl,kpoint)
c
	dimension ro(nx,ny,nz)
	integer*2 numob(nx,ny,nz)
C
	dimension kpoint(maxobl)
	integer*2 ibuf1(lbuf),ibuf2(lbuf),ibuf3(lbuf)
	integer*2 ibuf4(lbuf),ibuf5(lbuf),ibuf6(lbuf)
C
	do jz=1,nz
	  do jy=1,ny
	    do jx=1,nx
c         if(ro(jx,jy,jz).ge.rocrit) then
         if(ro(jx,jy,jz).le.rocri1.and.ro(jx,jy,jz).ge.rocri2) then
	          numob(jx,jy,jz)=-1
	        else
	          numob(jx,jy,jz)=0
	      end if
	    end do
	  end do
	end do
c
	numreg=0
C
	do jz=1,nz
	  do jy=1,ny
	    do jx=1,nx
	      if(numob(jx,jy,jz).eq.-1) then
	        numreg=numreg+1
	        call compon(nuprot,numob,nx,ny,nz,jx,jy,jz,numreg,lbuf,
     *                      ibuf1,ibuf2,ibuf3,ibuf4,ibuf5,ibuf6)
	      end if
	    end do
	  end do
	end do
c
	if(numreg.gt.maxobl) then
	  write(nuprot,*) 'The number of areas is ',numreg
	  write(nuprot,*) 'this is more then MAXOBL !!! ', maxobl
	end if
c
	do j=1,maxobl
	  kpoint(j)=0
	end do
c
	do jz=1,nz
	  do jy=1,ny
	    do jx=1,nx
 	      n=numob(jx,jy,jz)
 	      if(n.gt.0 .and. n.le.maxobl) kpoint(n)=kpoint(n)+1
	    end do
	  end do
	end do
c
	RETURN
	END
c
c---------------------------------------------------------
c
	SUBROUTINE compon(nuprot,numob,nx,ny,nz,jx,jy,jz,numreg,lbuf,
     *                    ifrolx,ifroly,ifrolz,ifrnwx,ifrnwy,ifrnwz)
c
	integer*2 numob(nx,ny,nz)
	integer*2 ifrolx(lbuf),ifroly(lbuf),ifrolz(lbuf)
	integer*2 ifrnwx(lbuf),ifrnwy(lbuf),ifrnwz(lbuf)
c
c                                                                     *
	nfrold=1
	ifrolx(1)=jx
	ifroly(1)=jy
	ifrolz(1)=jz
c
10      CONTINUE
c
          nfrnew=0
	  do jfo=1,nfrold
	    kx=ifrolx(jfo)
	    ky=ifroly(jfo)
	    kz=ifrolz(jfo)
	    call neibou(nuprot,numob,nx,ny,nz,kx,ky,kz,nfrnew,lbuf,
     *    	        ifrnwx,ifrnwy,ifrnwz)
	  end do
c
	  do jfo=1,nfrold
	    kx=ifrolx(jfo)
	    ky=ifroly(jfo)
	    kz=ifrolz(jfo)
	    numob(kx,ky,kz)=numreg
	  end do
c
	  if(nfrnew.eq.0) goto 20
	  nfrold=nfrnew
	  do j=1,nfrnew
	    ifrolx(j)=ifrnwx(j)
	    ifroly(j)=ifrnwy(j)
	    ifrolz(j)=ifrnwz(j)
	  end do
c
	GO TO 10
c
20      CONTINUE
c
	RETURN
	END
c
c-------------------------------------------------------------------
c
	SUBROUTINE neibou(nuprot,numob,nx,ny,nz,kx,ky,kz,nfrnew,lbuf,
     *	ifrnwx,ifrnwy,ifrnwz)

c
	integer*2 numob(nx,ny,nz)
	integer*2 ifrnwx(lbuf),ifrnwy(lbuf),ifrnwz(lbuf)
c
	lx=kx+1
	ly=ky
	lz=kz
	if(lx.gt.nx) lx=lx-nx
	if(numob(lx,ly,lz).eq.-1) then
	  nfrnew=nfrnew+1
	  if(nfrnew.gt.lbuf) goto 10
	  ifrnwx(nfrnew)=lx
	  ifrnwy(nfrnew)=ly
	  ifrnwz(nfrnew)=lz
	  numob(lx,ly,lz)=0
	end if
c
	lx=kx-1
	ly=ky
	lz=kz
	if(lx.lt.1) lx=lx+nx
	if(numob(lx,ly,lz).eq.-1) then
	  nfrnew=nfrnew+1
	  if(nfrnew.gt.lbuf) goto 10
	  ifrnwx(nfrnew)=lx
	  ifrnwy(nfrnew)=ly
	  ifrnwz(nfrnew)=lz
	  numob(lx,ly,lz)=0
	end if
c
	lx=kx
	ly=ky+1
	lz=kz
	if(ly.gt.ny) ly=ly-ny
	if(numob(lx,ly,lz).eq.-1) then
	  nfrnew=nfrnew+1
	  if(nfrnew.gt.lbuf) goto 10
	  ifrnwx(nfrnew)=lx
	  ifrnwy(nfrnew)=ly
	  ifrnwz(nfrnew)=lz
	  numob(lx,ly,lz)=0
	end if
c
	lx=kx
	ly=ky-1
	lz=kz
	if(ly.lt.1) ly=ly+ny
	if(numob(lx,ly,lz).eq.-1) then
	  nfrnew=nfrnew+1
	  if(nfrnew.gt.lbuf) goto 10
	  ifrnwx(nfrnew)=lx
	  ifrnwy(nfrnew)=ly
	  ifrnwz(nfrnew)=lz
	  numob(lx,ly,lz)=0
	end if
c
	lx=kx
	ly=ky
	lz=kz+1
	if(lz.gt.nz) lz=lz-nz
	if(numob(lx,ly,lz).eq.-1) then
	  nfrnew=nfrnew+1
	  if(nfrnew.gt.lbuf) goto 10
	  ifrnwx(nfrnew)=lx
	  ifrnwy(nfrnew)=ly
	  ifrnwz(nfrnew)=lz
	  numob(lx,ly,lz)=0
	end if
c
	lx=kx
	ly=ky
	lz=kz-1
	if(lz.lt.1) lz=lz+nz
	if(numob(lx,ly,lz).eq.-1) then
	  nfrnew=nfrnew+1
	  if(nfrnew.gt.lbuf) goto 10
	  ifrnwx(nfrnew)=lx
	  ifrnwy(nfrnew)=ly
	  ifrnwz(nfrnew)=lz
	  numob(lx,ly,lz)=0
	end if
c
c
	RETURN
c
10      CONTINUE
        write(nuprot,*) 'Too small dimension LBUF in SVIAZ2'
        STOP
c
	END
c
c-------------------------------------------------------------------
          SUBROUTINE intpha(kref,ph,pharad,phadef)
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
c   to interrprete the phase set ph (it's lenght = kref)
c   output parameter pharad = .true.  if abs<ave> < 5
c   output parameter pharad = .false. if abs<ave> >=50
c   output parameter phadef = .false. otherwise
cccccccccccccccccccccccccccccccccccccccccccccccccccccc
          dimension ph(kref)
          logical pharad,phadef
c
            summa=0.
            ave=0.
            do i=1,kref
               summa=summa+abs(ph(i))
            end do
            if (kref.ne.0) ave=summa/kref
            if(abs(ave).lt.5.) then
               pharad=.true.
               phadef=.true.
              elseif (abs(ave).ge.50.) then
               pharad=.false.
               phadef=.true.
              else
               phadef=.false.
          end if
          RETURN
          END
c********************************************************************
c
c   January 19, 2004
c
c   FFT1m FFT1    FT1  and 1-dim kernel were modified
c   INTR  ZERO
c
c
c*********************************************************************
c********************************************************************
c
c       ONE - DIMENSIONAL FAST FOURIER TRANSFORM
c       by L.Ten Eyck
c
c
c  modified by VL on January 19, 2004  - warning messages were calmed
c
c
c********************************************************************
C     fft033
c
      SUBROUTINE HERM FT (X, Y, N, DIM,nsize)
      INTEGER N
      INTEGER DIM(5)
      REAL X(1), Y(1)
C
C     HERMITIAN SYMMETRIC FOURIER TRANSFORM
C
C     GIVEN THE UNIQUE TERMS OF A HERMITIAN SYMMETRIC SEQUENCE OF LENGTH
C     2N THIS SUBROUTINE CALCULATES THE 2N REAL NUMBERS WHICH ARE ITS
C     FOURIER TRANSFORM.  THE EVEN NUMBERED ELEMENTS OF THE TRANSFORM
C     (0, 2, 4, . . ., 2N-2) ARE RETURNED IN X AND THE ODD NUMBERED
C     ELEMENTS (1, 3, 5, . . ., 2N-1) IN Y.
C
C     A FINITE HERMITIAN SEQUENCE OF LENGTH 2N CONTAINS N + 1 UNIQUE
C     REAL NUMBERS AND N - 1 UNIQUE IMAGINARY NUMBERS.  FOR CONVENIENCE
C     THE REAL VALUE FOR X(N) IS STORED AT Y(0).
C
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO N, TWO PI
      INTEGER NT, D2, D3, D4, D5
      INTEGER I, J, K, N OVER 2, I0, I1, I2
      INTEGER K1
C
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
C
      DO 100 I0 = 1, NT, D3
      I1 = I0 + D4
      DO 100 I = I0, I1, D5
      A = X(I)
      B = Y(I)
      X(I) = A + B
      Y(I) = A - B
  100 CONTINUE
C
      N OVER 2 = N/2 + 1
      IF (N OVER 2 .LT. 2) GO TO 500
      DO 400 I0 = 2, N OVER 2
      ANGLE = TWO PI*FLOAT(I0-1)/TWO N
      CO = COS(ANGLE)
      SI = SIN(ANGLE)
      K = (N + 2 - 2*I0)*D2
      K1 = (I0 - 1)*D2 + 1
      DO 300 I1 = K1, NT, D3
      I2 = I1 + D4
      DO 200 I = I1, I2, D5
      J = I + K
      A = X(I) + X(J)
      B = X(I) - X(J)
      C = Y(I) + Y(J)
      D = Y(I) - Y(J)
      E = B*CO + C*SI
      F = B*SI - C*CO
      X(I) = A + F
      X(J) = A - F
      Y(I) = E + D
      Y(J) = E - D
  200 CONTINUE
  300 CONTINUE
  400 CONTINUE
C
      CALL CMPL FT (X, Y, N, DIM,nsize)
C
  500 CONTINUE
      RETURN
C
      END
c
c--------------------------------------------------------------------
C     FFT038
C
      SUBROUTINE CMPL FT (X, Y, N, D,nl)
      INTEGER N
      INTEGER D(5)
      REAL X(1), Y(1)
C
C     COMPLEX FINITE DISCRETE FOURIER TRANSFORM
C     TRANSFORMS ONE DIMENSION OF MULTI-DIMENSIONAL DATA
C     MODIFIED BY L. F. TEN EYCK FROM A ONE-DIMENSIONAL VERSION WRITTEN
C     BY G. T. SANDE, 1969.
C
C     THIS PROGRAM CALCULATES THE TRANSFORM
C               (X(T) + I*Y(T))*(COS(2*PI*T/N) - I*SIN(2*PI*T/N))
C
C     INDEXING -- THE ARRANGEMENT OF THE MULTI-DIMENSIONAL DATA IS
C     SPECIFIED BY THE INTEGER ARRAY D, THE VALUES OF WHICH ARE USED AS
C     CONTROL PARAMETERS IN DO LOOPS.  WHEN IT IS DESIRED TO COVER ALL
C     ELEMENTS OF THE DATA FOR WHICH THE SUBSCRIPT BEING TRANSFORMED HAS
C     THE VALUE I0, THE FOLLOWING IS USED.
C
C               I1 = (I0 - 1)*D(2) + 1
C               DO 100 I2 = I1, D(1), D(3)
C               I3 = I2 + D(4) - 1
C               DO 100 I = I2, I3, D(5)
C                  .
C                  .
C           100 CONTINUE
C
C     WITH THIS INDEXING IT IS POSSIBLE TO USE A NUMBER OF ARRANGEMENTS
C     OF THE DATA, INCLUDING NORMAL FORTRAN COMPLEX NUMBERS (D(5) = 2)
C     OR SEPARATE STORAGE OF REAL AND IMAGINARY PARTS.
C
      LOGICAL ERROR
      INTEGER P MAX, P SYM, TWO GRP
      INTEGER FACTOR(15), SYM(15), UN SYM(15)
C
C     P MAX IS THE LARGEST PRIME FACTOR THAT WILL BE TOLERATED BY THIS
C     PROGRAM.
C     TWO GRP IS THE LARGEST POWER OF TWO THAT IS TREATED AS A SPECIAL
C     CASE.
C
      P MAX = 19
      TWO GRP = 8
C
      IF (N .LE. 1) GO TO 100
      CALL S R FP (N, P MAX, TWO GRP, FACTOR, SYM, P SYM, UN SYM, ERROR)
      IF (ERROR) GO TO 200
C
      CALL MD FT KD (N, FACTOR, D, X, Y,nl)
      CALL D IP RP (N, SYM, P SYM, UN SYM, D, X, Y,nl)
C
  100 CONTINUE
      RETURN
C
  200 CONTINUE
      WRITE (3,300) N
      STOP
C
  300 FORMAT (43H0INVALID NUMBER OF POINTS FOR CMPL FT.  N =, I10//)
C
      END
c
c--------------------------------------------------------------------
C     FFT039
C
      SUBROUTINE S R FP (PTS,PMAX,TWO GRP,FACTOR,SYM,P SYM,UN SYM,ERROR)
C     SYMMETRIZED REORDERING FACTORING PROGRAMME
C
      LOGICAL ERROR
      INTEGER PTS,PMAX,TWO GRP,P SYM
      INTEGER FACTOR (10), SYM (10), UN SYM (10)
C
      INTEGER PP(14), QQ (7)
      INTEGER F,J,JJ,N,NEST,P,P TWO,Q,R
C
      NEST=14
C
      N=PTS
      P SYM=1
      F=2
      P=0
      Q=0
  100 CONTINUE
      IF (N.LE.1) GO TO 500
      DO 200 J=F,PMAX
      IF (N.EQ.(N/J)*J) GO TO 300
  200 CONTINUE
      GO TO 1400
  300 CONTINUE
      IF (2*P+Q.GE.NEST) GO TO 1600
      F=J
      N=N/F
      IF (N.EQ.(N/F)*F) GO TO 400
      Q=Q+1
      QQ(Q)=F
      GO TO 100
  400 CONTINUE
      N=N/F
      P=P+1
      PP(P)=F
      P SYM=P SYM*F
      GO TO 100
C
  500 CONTINUE
      R=1
      IF (Q.EQ.0) R=0
      IF (P.LT.1) GO TO 700
      DO 600 J=1,P
      JJ=P+1-J
      SYM(J)=PP(JJ)
      FACTOR(J)=PP(JJ)
      JJ=P+Q+J
      FACTOR(JJ)=PP(J)
      JJ=P+R+J
      SYM(JJ)=PP(J)
  600 CONTINUE
  700 CONTINUE
      IF (Q.LT.1) GO TO 900
      DO 800 J=1,Q
      JJ=P+J
      UN SYM(J)=QQ(J)
      FACTOR(JJ)=QQ(J)
  800 CONTINUE
      SYM(P+1)=PTS/P SYM**2
  900 CONTINUE
      JJ=2*P+Q
      FACTOR(JJ+1)=0
      P TWO=1
      J=0
 1000 CONTINUE
      J=J+1
      IF (FACTOR(J).EQ.0) GO TO 1200
      IF (FACTOR(J).NE.2) GO TO 1000
      P TWO=P TWO*2
      FACTOR(J)=1
      IF (P TWO.GE.TWO GRP) GO TO 1100
      IF (FACTOR(J+1).EQ.2) GO TO 1000
 1100 CONTINUE
      FACTOR(J)=P TWO
      P TWO=1
      GO TO 1000
 1200 CONTINUE
      IF (P.EQ.0) R=0
      JJ=2*P+R
      SYM(JJ+1)=0
      IF (Q.LE.1) Q=0
      UN SYM(Q+1)=0
      ERROR=.FALSE.
C
 1300 CONTINUE
      goto 1800
C
 1400 CONTINUE
      WRITE (3,1500) PMAX, PTS
      ERROR=.TRUE.
      GO TO 1300
 1500 FORMAT (24H0LARGEST FACTOR EXCEEDS ,I3,7H.  N = ,I6,1H.)
C
 1600 CONTINUE
      WRITE (3,1700) NEST, PTS
      ERROR=.TRUE.
      GO TO 1300
 1700 FORMAT (22H0FACTOR COUNT EXCEEDS ,I3,7H.  N = ,I6,1H.)
C
1800  continue
      return
      END
c
c--------------------------------------------------------------------
C     FFT040
C
      SUBROUTINE D IP RP (PTS,SYM,P SYM,UN SYM,DIM,X,Y,nla)
C     DOUBLE IN PLACE REORDERING PROGRAMME
C
      INTEGER PTS,P SYM
      REAL X(nla), Y(nla)
      INTEGER SYM(10), UN SYM(10), DIM(5)
C
      REAL T
      LOGICAL ONE MOD
      INTEGER MODULO (14)
      INTEGER DK,JJ,KK,LK,MODS,MULT,NEST,P UN SYM,TEST
      INTEGER NT, SEP, DELTA, P, P0, P1, P2, P3, P4, P5, SIZE
C
      INTEGER S (14), U (14)
      INTEGER A,B,C,D,E,F,G,H,I,J,K,L,M,N
      INTEGER BS,CS,DS,ES,FS,GS,HS,IS,JS,KS,LS,MS,NS
      INTEGER AL,BL,CL,DL,EL,FL,GL,HL,IL,JL,KL,LL,ML,NL
      EQUIVALENCE           (AL,U(1)),(BS,S(2)),(BL,U(2))
      EQUIVALENCE (CS,S(3)),(CL,U(3)),(DS,S(4)),(DL,U(4))
      EQUIVALENCE (ES,S(5)),(EL,U(5)),(FS,S(6)),(FL,U(6))
      EQUIVALENCE (GS,S(7)),(GL,U(7)),(HS,S(8)),(HL,U(8))
      EQUIVALENCE (IS,S(9)),(IL,U(9)),(JS,S(10)),(JL,U(10))
      EQUIVALENCE (KS,S(11)),(KL,U(11)),(LS,S(12)),(LL,U(12))
      EQUIVALENCE (MS,S(13)),(ML,U(13)),(NS,S(14)),(NL,U(14))
C
      data MODS /0/
c
      NEST=14
C
      NT = DIM(1)
      SEP = DIM(2)
      P2 = DIM(3)
      SIZE = DIM(4) - 1
      P4 = DIM(5)
      IF (SYM(1).EQ.0) GO TO 500
      DO 100 J=1,NEST
      U(J)=1
      S(J)=1
  100 CONTINUE
      N=PTS
      DO 200 J=1,NEST
      IF (SYM(J).EQ.0) GO TO 300
      JJ=NEST+1-J
      U(JJ)=N
      S(JJ)=N/SYM(J)
      N=N/SYM(J)
  200 CONTINUE
  300 CONTINUE
C
      JJ=0
      DO 400 A=1,AL
      DO 400 B=A,BL,BS
      DO 400 C=B,CL,CS
      DO 400 D=C,DL,DS
      DO 400 E=D,EL,ES
      DO 400 F=E,FL,FS
      DO 400 G=F,GL,GS
      DO 400 H=G,HL,HS
      DO 400 I=H,IL,IS
      DO 400 J=I,JL,JS
      DO 400 K=J,KL,KS
      DO 400 L=K,LL,LS
      DO 400 M=L,ML,MS
      DO 400 N=M,NL,NS
      JJ=JJ+1
      IF (JJ.GE.N) GO TO 400
      DELTA = (N-JJ)*SEP
      P1 = (JJ-1)*SEP + 1
      DO 350 P0 = P1, NT, P2
      P3 = P0 + SIZE
      DO 350 P = P0, P3, P4
      P5 = P + DELTA
      T = X(P)
      X(P) = X(P5)
      X(P5) = T
      T = Y(P)
      Y(P) = Y(P5)
      Y(P5) = T
  350 CONTINUE
  400 CONTINUE
C
  500 CONTINUE
      IF (UN SYM(1).EQ.0) GO TO 1900
      P UN SYM=PTS/P SYM**2
      MULT=P UN SYM/UN SYM(1)
      TEST=(UN SYM(1)*UN SYM(2)-1)*MULT*P SYM
      LK=MULT
      DK=MULT
      DO 600 K=2,NEST
      IF (UN SYM(K).EQ.0) GO TO 700
      LK=LK*UN SYM(K-1)
      DK=DK/UN SYM(K)
      U(K)=(LK-DK)*P SYM
      MODS=K
  600 CONTINUE
  700 CONTINUE
      ONE MOD=MODS.LT.3
      IF (ONE MOD) GO TO 900
      DO 800 J=3,MODS
      JJ=MODS+3-J
      MODULO(JJ)=U(J)
  800 CONTINUE
  900 CONTINUE
      MODULO(2)=U(2)
      JL=(P UN SYM-3)*P SYM
      MS=P UN SYM*P SYM
C
      DO 1800 J=P SYM,JL,P SYM
      K=J
C
 1000 CONTINUE
      K=K*MULT
      IF (ONE MOD) GO TO 1200
      DO 1100 I=3,MODS
      K=K-(K/MODULO(I))*MODULO(I)
 1100 CONTINUE
 1200 CONTINUE
      IF (K.GE.TEST) GO TO 1300
      K=K-(K/MODULO(2))*MODULO(2)
      GO TO 1400
 1300 CONTINUE
      K=K-(K/MODULO(2))*MODULO(2)+MODULO(2)
 1400 CONTINUE
      IF (K.LT.J) GO TO 1000
C
      IF (K.EQ.J) GO TO 1700
      DELTA = (K-J)*SEP
      DO 1600 L=1,P SYM
      DO 1500 M=L,PTS,MS
      P1 = (M+J-1)*SEP + 1
      DO 1500 P0 = P1, NT, P2
      P3 = P0 + SIZE
      DO 1500 JJ = P0, P3, P4
      KK = JJ + DELTA
      T=X(JJ)
      X(JJ)=X(KK)
      X(KK)=T
      T=Y(JJ)
      Y(JJ)=Y(KK)
      Y(KK)=T
 1500 CONTINUE
 1600 CONTINUE
 1700 CONTINUE
 1800 CONTINUE
C
 1900 CONTINUE
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT041
C
      SUBROUTINE MD FT KD (N, FACTOR, DIM, X, Y,nl)
C     MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL DRIVER
C
      INTEGER N
      INTEGER FACTOR (10), DIM(5)
      REAL X(nl), Y(nl)
C
      INTEGER F, M, P, R, S
C
      S = DIM(2)
      F = 0
      M = N
  100 CONTINUE
      F = F + 1
      P = FACTOR(F)
      IF (P.EQ.0) RETURN
      M = M/P
      R = M*S
      IF (P.GT.8) GO TO 700
      GO TO (100, 200, 300, 400, 500, 800, 700, 600), P
      GO TO 800
C
  200 CONTINUE
      CALL R2 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), DIM,nl)
      GO TO 100
C
  300 CONTINUE
      CALL R3 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., DIM,nl)
      GO TO 100
C
  400 CONTINUE
      CALL R4 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), DIM,nl)
      GO TO 100
C
  500 CONTINUE
      CALL R5 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), DIM,nl)
      GO TO 100
C
  600 CONTINUE
      CALL R8 CFTK (N, M, X(1), Y(1), X(R+1), Y(R+1), X(2*R+1), Y(2*R+1)
     ., X(3*R+1), Y(3*R+1), X(4*R+1), Y(4*R+1), X(5*R+1), Y(5*R+1),
     .X(6*R+1), Y(6*R+1), X(7*R+1), Y(7*R+1), DIM,nl)
      GO TO 100
C
  700 CONTINUE
      CALL RP CFTK (N, M, P, R, X, Y, DIM)
      GO TO 100
C
  800 CONTINUE
      WRITE (3,900)
      RETURN
  900 FORMAT (34H0TRANSFER ERROR DETECTED IN MDFTKD,//)
      END
c
c--------------------------------------------------------------------
C     FFT042
C
      SUBROUTINE R2 CFTK (N, M, X0, Y0, X1, Y1, DIM,nl)
C     RADIX 2 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl), Y0(nl), X1(nl), Y1(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M2,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM2, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,C,IS,IU,RS,RU,S,TWOPI
      REAL FJM1, FM2
      DATA TWO PI/6.283185/
c
      data C,S /0.,0./
C
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M2=M*2
      FM2 = FLOAT(M2)
      M OVER 2=M/2+1
      MM2 = SEP*M2
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM2
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C=COS(ANGLE)
      S=SIN(ANGLE)
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      C=-C
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM2
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS=X0(K)+X1(K)
      IS=Y0(K)+Y1(K)
      RU=X0(K)-X1(K)
      IU=Y0(K)-Y1(K)
      X0(K)=RS
      Y0(K)=IS
      IF (ZERO) GO TO 300
      X1(K)=RU*C+IU*S
      Y1(K)=IU*C-RU*S
      GO TO 400
  300 CONTINUE
      X1(K)=RU
      Y1(K)=IU
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT043
C
      SUBROUTINE R3 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, DIM,nl)
C     RADIX 3 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl),Y0(nl),X1(nl),Y1(nl),
     * X2(nl), Y2(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M3,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM3, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,A,B,C1,C2,S1,S2,T,TWOPI
      REAL I0,I1,I2,IA,IB,IS,R0,R1,R2,RA,RB,RS
      REAL FJM1, FM3
      DATA TWO PI/6.2831853/,A/-0.5/, B/0.86602540/
C
      data c1,c2,s1,s2 /0.,0.,0.,0./
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M3=M*3
      FM3 = FLOAT(M3)
      MM3 = SEP*M3
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM3
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1*A+S1*B
      S1=C1*B-S1*A
      C1=T
      T=C2*A-S2*B
      S2=-C2*B-S2*A
      C2=T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM3
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      R0=X0(K)
      I0=Y0(K)
      RS=X1(K)+X2(K)
      IS=Y1(K)+Y2(K)
      X0(K)=R0+RS
      Y0(K)=I0+IS
      RA=R0+RS*A
      IA=I0+IS*A
      RB=(X1(K)-X2(K))*B
      IB=(Y1(K)-Y2(K))*B
      IF (ZERO) GO TO 300
      R1=RA+IB
      I1=IA-RB
      R2=RA-IB
      I2=IA+RB
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      GO TO 400
  300 CONTINUE
      X1(K)=RA+IB
      Y1(K) = IA-RB
      X2(K)=RA-IB
      Y2(K) = IA + RB
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT044
C
      SUBROUTINE R4 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, DIM,nl)
C     RADIX 4 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl), Y0(nl), X1(nl), Y1(nl)
      REAL X2(nl), Y2(nl), X3(nl), Y3(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M4,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM4, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,C1,C2,C3,S1,S2,S3,T,TWOPI
      REAL I1,I2,I3,IS0,IS1,IU0,IU1,R1,R2,R3,RS0,RS1,RU0,RU1
      REAL FJM1, FM4
      DATA TWO PI/6.283185/
C
      data c1,c2,c3,s1,s2,s3 /0.,0.,0.,0.,0.,0/
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M4=M*4
      FM4 = FLOAT(M4)
      MM4 = SEP*M4
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM4
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1
      C1=S1
      S1=T
      C2=-C2
      T=C3
      C3=-S3
      S3=-T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM4
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS0=X0(K)+X2(K)
      IS0=Y0(K)+Y2(K)
      RU0=X0(K)-X2(K)
      IU0=Y0(K)-Y2(K)
      RS1=X1(K)+X3(K)
      IS1=Y1(K)+Y3(K)
      RU1=X1(K)-X3(K)
      IU1=Y1(K)-Y3(K)
      X0(K)=RS0+RS1
      Y0(K)=IS0+IS1
      IF (ZERO) GO TO 300
      R1=RU0+IU1
      I1=IU0-RU1
      R2=RS0-RS1
      I2=IS0-IS1
      R3=RU0-IU1
      I3=IU0+RU1
      X2(K)=R1*C1+I1*S1
      Y2(K)=I1*C1-R1*S1
      X1(K)=R2*C2+I2*S2
      Y1(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      GO TO 400
  300 CONTINUE
      X2(K)=RU0+IU1
      Y2(K)=IU0-RU1
      X1(K)=RS0-RS1
      Y1(K)=IS0-IS1
      X3(K)=RU0-IU1
      Y3(K)=IU0+RU1
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT045
C
      SUBROUTINE R5 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4,
     . DIM,nl)
C     RADIX 5 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl), Y0(nl), X1(nl), Y1(nl),
     *   X2(nl), Y2(nl)
      REAL X3(nl), Y3(nl), X4(nl), Y4(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M5,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM5, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,A1,A2,B1,B2,C1,C2,C3,C4,S1,S2,S3,S4,T,TWOPI
      REAL R0,R1,R2,R3,R4,RA1,RA2,RB1,RB2,RS1,RS2,RU1,RU2
      REAL I0,I1,I2,I3,I4,IA1,IA2,IB1,IB2,IS1,IS2,IU1,IU2
      REAL FJM1, FM5
      DATA TWO PI/6.283185/, A1/0.30901699/, B1/0.95105652/,
     .      A2/-0.80901699/, B2/0.58778525/
C
      data c1,c2,c3,c4,s1,s2,s3,s4 /0.,0.,0.,0.,0.,0.,0.,0./
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M5=M*5
      FM5 = FLOAT(M5)
      MM5 = SEP*M5
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM5
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      C4=C2*C2-S2*S2
      S4=S2*C2+C2*S2
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=C1*A1+S1*B1
      S1=C1*B1-S1*A1
      C1=T
      T=C2*A2+S2*B2
      S2=C2*B2-S2*A2
      C2=T
      T=C3*A2-S3*B2
      S3=-C3*B2-S3*A2
      C3=T
      T=C4*A1-S4*B1
      S4=-C4*B1-S4*A1
      C4=T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM5
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      R0=X0(K)
      I0=Y0(K)
      RS1=X1(K)+X4(K)
      IS1=Y1(K)+Y4(K)
      RU1=X1(K)-X4(K)
      IU1=Y1(K)-Y4(K)
      RS2=X2(K)+X3(K)
      IS2=Y2(K)+Y3(K)
      RU2=X2(K)-X3(K)
      IU2=Y2(K)-Y3(K)
      X0(K)=R0+RS1+RS2
      Y0(K)=I0+IS1+IS2
      RA1=R0+RS1*A1+RS2*A2
      IA1=I0+IS1*A1+IS2*A2
      RA2=R0+RS1*A2+RS2*A1
      IA2=I0+IS1*A2+IS2*A1
      RB1=RU1*B1+RU2*B2
      IB1=IU1*B1+IU2*B2
      RB2=RU1*B2-RU2*B1
      IB2=IU1*B2-IU2*B1
      IF (ZERO) GO TO 300
      R1=RA1+IB1
      I1=IA1-RB1
      R2=RA2+IB2
      I2=IA2-RB2
      R3=RA2-IB2
      I3=IA2+RB2
      R4=RA1-IB1
      I4=IA1+RB1
      X1(K)=R1*C1+I1*S1
      Y1(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X3(K)=R3*C3+I3*S3
      Y3(K)=I3*C3-R3*S3
      X4(K)=R4*C4+I4*S4
      Y4(K)=I4*C4-R4*S4
      GO TO 400
  300 CONTINUE
      X1(K)=RA1+IB1
      Y1(K)=IA1-RB1
      X2(K)=RA2+IB2
      Y2(K)=IA2-RB2
      X3(K)=RA2-IB2
      Y3(K)=IA2+RB2
      X4(K)=RA1-IB1
      Y4(K)=IA1+RB1
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT046
C
      SUBROUTINE R8 CFTK (N, M, X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4,
     . X5, Y5, X6, Y6, X7, Y7, DIM,nl)
C     RADIX 8 MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, DIM(5)
      REAL X0(nl),Y0(nl), X1(nl),
     *    Y1(nl), X2(nl), Y2(nl)
      REAL X3(nl), Y3(nl), X4(nl),
     *   Y4(nl), X5(nl), Y5(nl)
      REAL X6(nl), Y6(nl), X7(nl), Y7(nl)
C
      LOGICAL FOLD,ZERO
      INTEGER J,K,K0,M8,M OVER 2
      INTEGER K1, K2, KK, L, L1, MM8, NT, SIZE, SEP
      INTEGER NS
      REAL ANGLE,C1,C2,C3,C4,C5,C6,C7,E,S1,S2,S3,S4,S5,S6,S7,T,TWOPI
      REAL R1,R2,R3,R4,R5,R6,R7,RS0,RS1,RS2,RS3,RU0,RU1,RU2,RU3
      REAL I1,I2,I3,I4,I5,I6,I7,IS0,IS1,IS2,IS3,IU0,IU1,IU2,IU3
      REAL RSS0,RSS1,RSU0,RSU1,RUS0,RUS1,RUU0,RUU1
      REAL ISS0,ISS1,ISU0,ISU1,IUS0,IUS1,IUU0,IUU1
      REAL FJM1, FM8
      DATA TWO PI/6.283185/, E/0.70710678/
C
      data c1,c2,c3,c4,c5,c6,c7 /0.,0.,0.,0.,0.,0.,0./
      data s1,s2,s3,s4,s5,s6,s7 /0.,0.,0.,0.,0.,0.,0./
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M8=M*8
      FM8 = FLOAT(M8)
      MM8 = SEP*M8
      M OVER 2=M/2+1
C
      FJM1 = -1.0
      DO 600 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FM8
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 200
      C1=COS(ANGLE)
      S1=SIN(ANGLE)
      C2=C1*C1-S1*S1
      S2=S1*C1+C1*S1
      C3=C2*C1-S2*S1
      S3=S2*C1+C2*S1
      C4=C2*C2-S2*S2
      S4=S2*C2+C2*S2
      C5=C4*C1-S4*S1
      S5=S4*C1+C4*S1
      C6=C4*C2-S4*S2
      S6=S4*C2+C4*S2
      C7=C4*C3-S4*S3
      S7=S4*C3+C4*S3
      GO TO 200
  100 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      T=(C1+S1)*E
      S1=(C1-S1)*E
      C1=T
      T=S2
      S2=C2
      C2=T
      T=(-C3+S3)*E
      S3=(C3+S3)*E
      C3=T
      C4=-C4
      T=-(C5+S5)*E
      S5=(-C5+S5)*E
      C5=T
      T=-S6
      S6=-C6
      C6=T
      T=(C7-S7)*E
      S7=-(C7+S7)*E
      C7=T
  200 CONTINUE
C
      DO 500 KK = K0, NS, MM8
      DO 440 L = KK, NT, L1
      K1 = L + SIZE
      DO 420 K = L, K1, K2
      RS0=X0(K)+X4(K)
      IS0=Y0(K)+Y4(K)
      RU0=X0(K)-X4(K)
      IU0=Y0(K)-Y4(K)
      RS1=X1(K)+X5(K)
      IS1=Y1(K)+Y5(K)
      RU1=X1(K)-X5(K)
      IU1=Y1(K)-Y5(K)
      RS2=X2(K)+X6(K)
      IS2=Y2(K)+Y6(K)
      RU2=X2(K)-X6(K)
      IU2=Y2(K)-Y6(K)
      RS3=X3(K)+X7(K)
      IS3=Y3(K)+Y7(K)
      RU3=X3(K)-X7(K)
      IU3=Y3(K)-Y7(K)
      RSS0=RS0+RS2
      ISS0=IS0+IS2
      RSU0=RS0-RS2
      ISU0=IS0-IS2
      RSS1=RS1+RS3
      ISS1=IS1+IS3
      RSU1=RS1-RS3
      ISU1=IS1-IS3
      RUS0=RU0-IU2
      IUS0=IU0+RU2
      RUU0=RU0+IU2
      IUU0=IU0-RU2
      RUS1=RU1-IU3
      IUS1=IU1+RU3
      RUU1=RU1+IU3
      IUU1=IU1-RU3
      T=(RUS1+IUS1)*E
      IUS1=(IUS1-RUS1)*E
      RUS1=T
      T=(RUU1+IUU1)*E
      IUU1=(IUU1-RUU1)*E
      RUU1=T
      X0(K)=RSS0+RSS1
      Y0(K)=ISS0+ISS1
      IF (ZERO) GO TO 300
      R1=RUU0+RUU1
      I1=IUU0+IUU1
      R2=RSU0+ISU1
      I2=ISU0-RSU1
      R3=RUS0+IUS1
      I3=IUS0-RUS1
      R4=RSS0-RSS1
      I4=ISS0-ISS1
      R5=RUU0-RUU1
      I5=IUU0-IUU1
      R6=RSU0-ISU1
      I6=ISU0+RSU1
      R7=RUS0-IUS1
      I7=IUS0+RUS1
      X4(K)=R1*C1+I1*S1
      Y4(K)=I1*C1-R1*S1
      X2(K)=R2*C2+I2*S2
      Y2(K)=I2*C2-R2*S2
      X6(K)=R3*C3+I3*S3
      Y6(K)=I3*C3-R3*S3
      X1(K)=R4*C4+I4*S4
      Y1(K)=I4*C4-R4*S4
      X5(K)=R5*C5+I5*S5
      Y5(K)=I5*C5-R5*S5
      X3(K)=R6*C6+I6*S6
      Y3(K)=I6*C6-R6*S6
      X7(K)=R7*C7+I7*S7
      Y7(K)=I7*C7-R7*S7
      GO TO 400
  300 CONTINUE
      X4(K)=RUU0+RUU1
      Y4(K)=IUU0+IUU1
      X2(K)=RSU0+ISU1
      Y2(K)=ISU0-RSU1
      X6(K)=RUS0+IUS1
      Y6(K)=IUS0-RUS1
      X1(K)=RSS0-RSS1
      Y1(K)=ISS0-ISS1
      X5(K)=RUU0-RUU1
      Y5(K)=IUU0-IUU1
      X3(K)=RSU0-ISU1
      Y3(K)=ISU0+RSU1
      X7(K)=RUS0-IUS1
      Y7(K)=IUS0+RUS1
  400 CONTINUE
  420 CONTINUE
  440 CONTINUE
  500 CONTINUE
      IF (FOLD) GO TO 100
  600 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT047
C
      SUBROUTINE RP CFTK (N, M, P, R, X, Y, DIM)
C     RADIX PRIME MULTI-DIMENSIONAL COMPLEX FOURIER TRANSFORM KERNEL
C
      INTEGER N, M, P, R, DIM(5)
c      REAL X(R,P), Y(R,P)
      real x(r,p),y(r,p)
C
      LOGICAL FOLD,ZERO
      REAL ANGLE,IS,IU,RS,RU,T,TWOPI,XT,YT
      REAL FU, FP, FJM1, FMP
      INTEGER J,JJ,K0,K,M OVER 2,MP,PM,PP,U,V
      INTEGER K1, K2, KK, L, L1, MMP, NT, SIZE, SEP
      INTEGER NS
C
      REAL AA (9,9), BB (9,9)
      REAL A (18), B (18), C (18), S (18)
      REAL IA (9), IB (9), RA (9), RB (9)
      data two pi/6.283185/
c
      NT = DIM(1)
      SEP = DIM(2)
      L1 = DIM(3)
      SIZE = DIM(4) - 1
      K2 = DIM(5)
      NS = N*SEP
      M OVER 2=M/2+1
      MP=M*P
      FMP = FLOAT(MP)
      MMP = SEP*MP
      PP=P/2
      PM=P-1
      FP = FLOAT(P)
      FU = 0.0
      DO 100 U=1,PP
      FU = FU + 1.0
      ANGLE = TWO PI*FU/FP
      JJ=P-U
      A(U)=COS(ANGLE)
      B(U)=SIN(ANGLE)
      A(JJ)=A(U)
      B(JJ)=-B(U)
  100 CONTINUE
      DO 300 U=1,PP
      DO 200 V=1,PP
      JJ=U*V-U*V/P*P
      AA(V,U)=A(JJ)
      BB(V,U)=B(JJ)
  200 CONTINUE
  300 CONTINUE
C
      FJM1 = -1.0
      DO 1500 J=1,M OVER 2
      FOLD=J.GT.1 .AND. 2*J.LT.M+2
      K0 = (J-1)*SEP + 1
      FJM1 = FJM1 + 1.0
      ANGLE = TWO PI*FJM1/FMP
      ZERO=ANGLE.EQ.0.0
      IF (ZERO) GO TO 700
      C(1)=COS(ANGLE)
      S(1)=SIN(ANGLE)
      DO 400 U=2,PM
      C(U)=C(U-1)*C(1)-S(U-1)*S(1)
      S(U)=S(U-1)*C(1)+C(U-1)*S(1)
  400 CONTINUE
      GO TO 700
  500 CONTINUE
      FOLD=.FALSE.
      K0 = (M+1-J)*SEP + 1
      DO 600 U=1,PM
      T=C(U)*A(U)+S(U)*B(U)
      S(U)=-S(U)*A(U)+C(U)*B(U)
      C(U)=T
  600 CONTINUE
  700 CONTINUE
C
      DO 1400 KK = K0, NS, MMP
      DO 1340 L = KK, NT, L1
      K1 = L + SIZE
      DO 1320 K = L, K1, K2
      XT=X(K,1)
      YT=Y(K,1)
      RS=X(K,2)+X(K,P)
      IS=Y(K,2)+Y(K,P)
      RU=X(K,2)-X(K,P)
      IU=Y(K,2)-Y(K,P)
      DO 800 U=1,PP
      RA(U)=XT+RS*AA(U,1)
      IA(U)=YT+IS*AA(U,1)
      RB(U)=RU*BB(U,1)
      IB(U)=IU*BB(U,1)
  800 CONTINUE
      XT=XT+RS
      YT=YT+IS
      DO 1000 U=2,PP
      JJ=P-U
      RS=X(K,U+1)+X(K,JJ+1)
      IS=Y(K,U+1)+Y(K,JJ+1)
      RU=X(K,U+1)-X(K,JJ+1)
      IU=Y(K,U+1)-Y(K,JJ+1)
      XT=XT+RS
      YT=YT+IS
      DO 900 V=1,PP
      RA(V)=RA(V)+RS*AA(V,U)
      IA(V)=IA(V)+IS*AA(V,U)
      RB(V)=RB(V)+RU*BB(V,U)
      IB(V)=IB(V)+IU*BB(V,U)
  900 CONTINUE
 1000 CONTINUE
      X(K,1)=XT
      Y(K,1)=YT
      DO 1300 U=1,PP
      JJ=P-U
      IF (ZERO) GO TO 1100
      XT=RA(U)+IB(U)
      YT=IA(U)-RB(U)
      X(K,U+1)=XT*C(U)+YT*S(U)
      Y(K,U+1)=YT*C(U)-XT*S(U)
      XT=RA(U)-IB(U)
      YT=IA(U)+RB(U)
      X(K,JJ+1)=XT*C(JJ)+YT*S(JJ)
      Y(K,JJ+1)=YT*C(JJ)-XT*S(JJ)
      GO TO 1200
 1100 CONTINUE
      X(K,U+1)=RA(U)+IB(U)
      Y(K,U+1)=IA(U)-RB(U)
      X(K,JJ+1)=RA(U)-IB(U)
      Y(K,JJ+1)=IA(U)+RB(U)
 1200 CONTINUE
 1300 CONTINUE
 1320 CONTINUE
 1340 CONTINUE
 1400 CONTINUE
      IF (FOLD) GO TO 500
 1500 CONTINUE
C
      RETURN
      END
c
c--------------------------------------------------------------------
C     FFT034
C
      SUBROUTINE REAL FT (EVEN, ODD, N, DIM,nsize)
      INTEGER N
      INTEGER DIM(5)
      REAL EVEN(nsize), ODD(nsize)
C
C     REAL FOURIER TRANSFORM
C
C     GIVEN A REAL SEQUENCE OF LENGTH 2N THIS SUBROUTINE CALCULATES THE
C     UNIQUE PART OF THE FOURIER TRANSFORM.  THE FOURIER TRANSFORM HAS
C     N + 1 UNIQUE REAL PARTS AND N - 1 UNIQUE IMAGINARY PARTS.  SINCE
C     THE REAL PART AT X(N) IS FREQUENTLY OF INTEREST, THIS SUBROUTINE
C     STORES IT AT X(N) RATHER THAN IN Y(0).  THEREFORE X AND Y MUST BE
C     OF LENGTH N + 1 INSTEAD OF N.  NOTE THAT THIS STORAGE ARRANGEMENT
C     IS DIFFERENT FROM THAT EMPLOYED BY THE HERMITIAN FOURIER TRANSFORM
C     SUBROUTINE.
C
C     FOR CONVENIENCE THE DATA IS PRESENTED IN TWO PARTS, THE FIRST
C     CONTAINING THE EVEN NUMBERED REAL TERMS AND THE SECOND CONTAINING
C     THE ODD NUMBERED TERMS (NUMBERING STARTING AT 0).  ON RETURN THE
C     REAL PART OF THE TRANSFORM REPLACES THE EVEN TERMS AND THE
C     IMAGINARY PART OF THE TRANSFORM REPLACES THE ODD TERMS.
C
      REAL A, B, C, D, E, F, ANGLE, CO, SI, TWO PI, TWO N
      INTEGER NT, D2, D3, D4, D5
      INTEGER I, J, K, L, N OVER 2, I0, I1, I2
C
      TWO PI = 6.283185
      TWO N = FLOAT(2*N)
C
      CALL CMPL FT (EVEN, ODD, N, DIM,nsize)
C
      NT = DIM(1)
      D2 = DIM(2)
      D3 = DIM(3)
      D4 = DIM(4) - 1
      D5 = DIM(5)
      N OVER 2 = N/2 + 1
C
      IF (N OVER 2 .LT. 2) GO TO 400
      DO 300 I = 2, N OVER 2
      ANGLE = TWO PI*FLOAT(I-1)/TWO N
      CO = COS(ANGLE)
      SI = SIN(ANGLE)
      I0 = (I - 1)*D2 + 1
      J = (N + 2 - 2*I)*D2
      DO 200 I1 = I0, NT, D3
      I2 = I1 + D4
      DO 100 K = I1, I2, D5
      L = K + J
      A = (EVEN(L) + EVEN(K))/2.0
      C = (EVEN(L) - EVEN(K))/2.0
      B = (ODD(L) + ODD(K))/2.0
      D=(ODD(L)-ODD(K))/2.0
      E = C*SI + B*CO
      F = C*CO - B*SI
      EVEN(K) = A + E
      EVEN(L) = A - E
      ODD(K) = F - D
      ODD(L) = F + D
  100 CONTINUE
  200 CONTINUE
  300 CONTINUE
C
  400 CONTINUE
      IF (N .LT. 1) GO TO 600
      J = N*D2
      DO 500 I1 = 1, NT, D3
      I2 = I1 + D4
      DO 500 K = I1, I2, D5
      L = K + J
      EVEN(L) = EVEN(K) - ODD(K)
      ODD(L) = 0.0
      EVEN(K) = EVEN(K) + ODD(K)
      ODD(K) = 0.0
  500 CONTINUE
C
  600 CONTINUE
      RETURN
C
      END
C--------------------------------------------------------------------
c********************************************************************
c********************************************************************
c--------------------------------------------------------------------
c                                                          29.03.85
C         M_FT1                                             V.Yu.Lunin
c
c
c         The subroutine performs the Fourier transform
c
C
C                                                 H*R   K*S   L*T
C         RO(R,S,T)=SUMMA   F(H,K,L)*EXP(-2*PI*I*(--- + --- + ---))
C                   H=0,NX-1                       NX    NY    NZ
C                   K=0,NY-1
C                   L=0,NZ-1
C
C         for  MINX<=R<=MAXX,MINY<=S<=MAXY,MINZ<=T<=MAXZ
C         suppousing RO(.,.,.) be a real-value function.
C
C
c         INPUT DATA
c         X - data to be transformed;
c             this array is considered as three-dimensional COMPLEX
c             array with dimensions (maxl+1) Nx Ny;
c             elements X(l+1,h+1,k+1) contain values of structure
c             factors (Fourier coefficients) F(h,k,l)  for
C                   -MAXH<=H<=MAXH,-MAXK<=K<=MAXK,0<=L<=MAXL
C                   (it is assumed that F(-H,K,L)=F(NX-H,K,L) ,
C                                  F(H,-K,L)=F(H,NY-K ,L) )
c             and zero values for other indexes.
c          Nx,Ny,Nz - numbers of divisions along unit cell axes;
c          maxh,maxk,maxl - restrict the indexes of nonzero structure
c             factors,
c          minx,maxx,miny,maxy,minz,maxz - restrict the part of the
c             unit cell there transform will be calculated;
c
c          OUTPUT DATA
c          X - Fourier synthesis Ro;
c              this array is considered as three-dimensional REAL array
c              with dimensions Nz  Nx  Ny;
c              elements X(t+1,r+1,s+1) contain values Ro(r,s,t);
c              the only defined Ro-values are ones with
c              minx<=r<=maxx, miny<=s<=maxy, minz<=t<=maxz;
c
c          ATTENTION
c            - the total length X-array (as real one) must be
c              Nx*Ny*Nz at least;
c            - the indexes order in input data  l h k
c                                in output data z x y;
C
C            -    NZ - must be even;
C                 NX >= 2*MAXH+1
C                 NY>=2*MAXK+1
C                 NZ>=2*MAXL+2
C                 0<=MINX<=MAXX<=NX-1
C                 0<=MINY<=MAXY<=NY-1
C                 0<=MINZ<=MAXZ<=NZ-1
C            - the Hermitian  symmetry
C                                         *                            *
C                      F(H,K,0)=F(-H,-K,0)   ,F(H,K,NZ/2)=F(-H,-K,NZ/2)
c               must be present in input data.
C
C
c          SUBROUTINE USED
c             one-dimensional Fast Fourier Transform package of
c             L.F.Ten Eyck;
c             FT1A
C
c
      SUBROUTINE M_FT1(X,NX,NY,NZ,MAXH,MAXL,MINX,MAXX,MINY,MAXY,
     *               nsize)
C
      DIMENSION X(nsize),K(5)
C
C
C
      K(1)=2*(MAXL+1)*NX*NY
      K(2)=2*(MAXL+1)*NX
      K(3)=2*(MAXL+1)*NX*NY
      K(4)=2*(MAXL+1)*(MAXH+1)
      K(5)=2
      CALL CMPLFT(X(1),X(2),NY,K,nsize)
C
      K(4)=2*(MAXL+1)*MAXH
      JA=(NX-MAXH)*2*(MAXL+1)+1
      CALL CMPLFT(X(JA),X(JA+1),NY,K,nsize)
C
C
C
      JA=MINY*2*(MAXL+1)*NX+1
      K(1)=2*(MAXL+1)*NX*(MAXY-MINY+1)
      K(2)=2*(MAXL+1)
      K(3)=2*(MAXL+1)*NX
      K(4)=2*(MAXL+1)
      K(5)=2
      CALL CMPLFT(X(JA),X(JA+1),NX,K,nsize)
C
C
C
      N3=2*(MAXL+1)
      IF(N3.EQ.NZ) GOTO 50
      CALL FT1A(X,N3,NX,NY,X,NZ,NX,NY)
50    CONTINUE
C
C
      JA=    NZ*NX*MINY+    NZ*MINX+1
      K(1)=    NZ*NX*(MAXY-MINY+1)
      K(2)=2
      K(3)=    NZ*NX
      K(4)=    NZ*(MAXX-MINX+1)
      K(5)=NZ
C
C
C
      K1=K(1)
      K3=K(3)
      K5=K(5)
C
C
      IF(N3.EQ.NZ) GOTO 220
      DO 210 J1=JA,K1,K3
      K4=K(4)+J1-1
      DO 200 J=J1,K4,K5
      K6=J+N3
      K7=J+NZ-1
      DO 190 J2=K6,K7
      X(J2)=0.
190   CONTINUE
200   CONTINUE
210   CONTINUE
C
C
220   CONTINUE
C
C
C
      CALL HERMFT(X(JA),X(JA+1),NZ/2,K,nsize)
C
      RETURN
      END
c
c--------------------------------------------------------------------
c     The  decompressing the X-array into Y-array.
c
c     ATTENTION !
c     It is suppoused n1<=k1, n2<=k2, n3<=k3.
c
      SUBROUTINE FT1A(X,n1,n2,n3,Y,k1,k2,k3)
c
      dimension X(n1,n2,n3), Y(k1,k2,k3)
c
      do 50 i3=1,n3
        m3=n3-i3+1
        do 40 i2=1,n2
          m2=n2-i2+1
          do 30 i1=1,n1
            m1=n1-i1+1
            Y(m1,m2,m3)=X(m1,m2,m3)
30        continue
40      continue
50    continue
c
c
      return
      end
c
c********************************************************************
c*********************************************************************
c  *********                                      9 FEBRUARY 2000
c  * FFT1M *                                      V.Yu.Lunin
c  *********
c
c     This subriutine replace FFT1 - subroutine. The difference
c     is that it use as the input the resolution limits and
c     calculate the synthesis of the specified resolution.
c
c     9.02.2000   the reflections with the f(.)=1.e10 or
c                 f(.)=0. or phi(.)=1.e10
c                 are excluded from the calculation
c
c                 the number of the used undependent reflections
c                 is returned in the INCREF
c
      SUBROUTINE FFT1M(nsym,sym,nref,ih,ik,il,f,phi,nx,ny,nz,
     *                ro,mes,
     *                ssmin,ssmax,ss,incref)
      dimension sym(12,nsym)
      dimension ih(nref),ik(nref),il(nref),f(nref),phi(nref)
      dimension ro(nx,ny,nz)
      dimension ss(nref)
c
c         The subroutine performs the Fourier transform
C
C                                                 h*r   k*s   l*t
C         ro(r,s,t)=SUMMA   F(h,k,l)*EXP(-2*PI*I*(--- + --- + ---))
C                   h,k,l                          nx    ny    nz
C
C         for  0<=r<=nx-1, 0<=s<=ny-1, 0<=t<=nz-1
C         suppousing ro(.,.,.) be a real-value function.
c
c     INPUT DATA
c       nsym - number of symmetries operations, which will be applied
c              to input structure factors;
c       sym(.,.) - crystallographic symmetries operations for real
c              space with the order of elemets
c              g11,g21,g31,g12,g22,g32,g13,g23,g33,t1,t2,t3
c       nref - number of reflections to be used;
c       ih(.),ik(.),il(.) - there indexes;
c       f(.),phi(.) - there phases (in RADIANS)
c       nx,ny,nz - number of divisions along the unit cell sides;
c       mes - a number of the unit for abnormal messages;
c       ssmin,ssmax - only the structure factors with SS(.) in these
c                     limits are used for the synthesis calculation
c       ss(.) - the array of s**2 values
c
c     OUTPUT DATA
c       ro(.,.,.) - calculated Fourier Transform
c       incref - the number of reflections from the input list
c                which were taken into the calculation
c
c     ATTENTION
c       - nx must be even;
c       - for calculations will be used all reflections prepared
c         with the use of specified symmetries and Hermitian symmetry,
c         provided that
c            !h!<=(nx-2)/2, !k!<=(ny-1)/2, !l!<=(nz-1)/2
c
c      NECESSARY SUBROUTINES
c        FFTKER.FOR - suite
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      twopi=6.2831852
      const=1.e10
      incref=0
      if((nx/2)*2.ne.nx) then
        if(mes.gt.0) write(mes,1000) nx
        STOP
      endif
      minh=0
      maxh=(nx-2)/2
      maxk=(ny-1)/2
      mink=-maxk
      maxl=(nz-1)/2
      minl=-maxl
      minx=0
      maxx=nx-1
      miny=0
      maxy=ny-1
      minz=0
      maxz=nz-1
c
c         preparing structure factors array
c
      ntotal=nx*ny*nz
      CALL ZERO(ro,ntotal)
c
      do jref=1,nref
      if(ssmin.le.ss(jref) .and. ss(jref).le.ssmax
     * .and. f(jref).ne.const .and. phi(jref).ne.const
     * .and. f(jref).ne.0.) then
c
        incref=incref+1
        jh=ih(jref)
        jk=ik(jref)
        jl=il(jref)

        do jsym=1,nsym
          m11=INTR(sym(1,jsym))
          m21=INTR(sym(2,jsym))
          m31=INTR(sym(3,jsym))
          m12=INTR(sym(4,jsym))
          m22=INTR(sym(5,jsym))
          m32=INTR(sym(6,jsym))
          m13=INTR(sym(7,jsym))
          m23=INTR(sym(8,jsym))
          m33=INTR(sym(9,jsym))
          t1=-sym(10,jsym)*twopi
          t2=-sym(11,jsym)*twopi
          t3=-sym(12,jsym)*twopi
c
          kh=m11*jh+m21*jk+m31*jl
          kk=m12*jh+m22*jk+m32*jl
          kl=m13*jh+m23*jk+m33*jl
c
          if(kh.ge.minh .and. kh.le.maxh .and.
     *       kk.ge.mink .and. kk.le.maxk .and.
     *       kl.ge.minl .and. kl.le.maxl) then
               fw=f(jref)
               pw=phi(jref)+t1*jh+t2*jk+t3*jl
               i1=2*kh+1
               if(kk.ge.0) then
                 i2=kk+1
               else
                 i2=ny+kk+1
               endif
               if(kl.ge.0) then
                 i3=kl+1
               else
                 i3=nz+kl+1
               endif
               ro(i1,i2,i3)=fw*cos(pw)
               ro(i1+1,i2,i3)=fw*sin(pw)
          endif
c
          kh=-kh
          kk=-kk
          kl=-kl
          if(kh.ge.minh .and. kh.le.maxh .and.
     *       kk.ge.mink .and. kk.le.maxk .and.
     *       kl.ge.minl .and. kl.le.maxl ) then
               fw=f(jref)
               pw=-phi(jref)-t1*jh-t2*jk-t3*jl
               i1=2*kh+1
               if(kk.ge.0) then
                 i2=kk+1
               else
                 i2=ny+kk+1
               endif
               if(kl.ge.0) then
                 i3=kl+1
               else
                 i3=nz+kl+1
               endif
               ro(i1,i2,i3)=fw*cos(pw)
               ro(i1+1,i2,i3)=fw*sin(pw)
          endif
        enddo
      endif
      enddo
c
c        the changing oif variables is connected with some crazy
c        things in organizing of FT1 subroutine
c
      CALL M_FT1(ro,ny,nz,nx,maxk,maxh,miny,maxy,minz,maxz,
     *         ntotal)
c
      RETURN
c
1000  format(1x,'** FFT1 **  the first dimension must be even, not',
     *       i5)
c
      END
c
c -------------------------------------------------------------------
c*********************************************************************
c  ********                                         18 September 1997
c  * FFT1 *                                         V.Yu.Lunin
c  ********
c
      SUBROUTINE FFT1(nsym,sym,nref,ih,ik,il,f,phi,nx,ny,nz,
     *                ro,mes)
      dimension sym(12,nsym)
      dimension ih(nref),ik(nref),il(nref),f(nref),phi(nref)
      dimension ro(nx,ny,nz)
c
c         The subroutine performs the Fourier transform
C
C                                                 h*r   k*s   l*t
C         ro(r,s,t)=SUMMA   F(h,k,l)*EXP(-2*PI*I*(--- + --- + ---))
C                   h,k,l                          nx    ny    nz
C
C         for  0<=r<=nx-1, 0<=s<=ny-1, 0<=t<=nz-1
C         suppousing ro(.,.,.) be a real-value function.
c
c     INPUT DATA
c       nsym - number of symmetries operations, which will be applied
c              to input structure factors;
c       sym(.,.) - crystallographic symmetries operations for real
c              space with the order of elemets
c              g11,g21,g31,g12,g22,g32,g13,g23,g33,t1,t2,t3
c       nref - number of reflections to be used;
c       ih(.),ik(.),il(.) - there indexes;
c       f(.),phi(.) - there phases (in RADIANS)
c       nx,ny,nz - number of divisions along the unit cell sides;
c       mes - a number of the unit for abnormal messages;
c
c     OUTPUT DATA
c       ro(.,.,.) - calculated Fourier Transform
c
c     ATTENTION
c       - nx must be even;
c       - for calculations will be used all reflections prepared
c         with the use of specified symmetries and Hermitian symmetry,
c         provided that
c            !h!<=(nx-2)/2, !k!<=(ny-1)/2, !l!<=(nz-1)/2
c
c      NECESSARY SUBROUTINES
c        FFTKER.FOR - suite
c - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
c
      twopi=6.2831852
      if((nx/2)*2.ne.nx) then
        if(mes.gt.0) write(mes,1000) nx
        STOP
      endif
      minh=0
      maxh=(nx-2)/2
      maxk=(ny-1)/2
      mink=-maxk
      maxl=(nz-1)/2
      minl=-maxl
      minx=0
      maxx=nx-1
      miny=0
      maxy=ny-1
      minz=0
      maxz=nz-1
c
c         preparing structure factors array
c
      ntotal=nx*ny*nz
      CALL ZERO(ro,ntotal)
c
      do jref=1,nref
        jh=ih(jref)
        jk=ik(jref)
        jl=il(jref)

        do jsym=1,nsym
          m11=INTR(sym(1,jsym))
          m21=INTR(sym(2,jsym))
          m31=INTR(sym(3,jsym))
          m12=INTR(sym(4,jsym))
          m22=INTR(sym(5,jsym))
          m32=INTR(sym(6,jsym))
          m13=INTR(sym(7,jsym))
          m23=INTR(sym(8,jsym))
          m33=INTR(sym(9,jsym))
          t1=-sym(10,jsym)*twopi
          t2=-sym(11,jsym)*twopi
          t3=-sym(12,jsym)*twopi
c
          kh=m11*jh+m21*jk+m31*jl
          kk=m12*jh+m22*jk+m32*jl
          kl=m13*jh+m23*jk+m33*jl
c
          if(kh.ge.minh .and. kh.le.maxh .and.
     *       kk.ge.mink .and. kk.le.maxk .and.
     *       kl.ge.minl .and. kl.le.maxl ) then
               fw=f(jref)
               pw=phi(jref)+t1*jh+t2*jk+t3*jl
               i1=2*kh+1
               if(kk.ge.0) then
                 i2=kk+1
               else
                 i2=ny+kk+1
               endif
               if(kl.ge.0) then
                 i3=kl+1
               else
                 i3=nz+kl+1
               endif
               ro(i1,i2,i3)=fw*cos(pw)
               ro(i1+1,i2,i3)=fw*sin(pw)
          endif
c
          kh=-kh
          kk=-kk
          kl=-kl
          if(kh.ge.minh .and. kh.le.maxh .and.
     *       kk.ge.mink .and. kk.le.maxk .and.
     *       kl.ge.minl .and. kl.le.maxl ) then
               fw=f(jref)
               pw=-phi(jref)-t1*jh-t2*jk-t3*jl
               i1=2*kh+1
               if(kk.ge.0) then
                 i2=kk+1
               else
                 i2=ny+kk+1
               endif
               if(kl.ge.0) then
                 i3=kl+1
               else
                 i3=nz+kl+1
               endif
               ro(i1,i2,i3)=fw*cos(pw)
               ro(i1+1,i2,i3)=fw*sin(pw)
          endif
        enddo
      enddo
c
c        the changing oif variables is connected with some crazy
c        things in organizing of FT1 subroutine
c
      CALL M_FT1(ro,ny,nz,nx,maxk,maxh,miny,maxy,minz,maxz,
     *         ntotal)
c
      RETURN
c
1000  format(1x,'** FFT1 **  the first dimension must be even, not',
     *       i5)
c
      END
c
c -------------------------------------------------------------------
c
      SUBROUTINE ZERO(x,n)
      dimension x(n)
      do j=1,n
        x(j)=0.
      enddo
      RETURN
      END
c
c--------------------------------------------------------------------
c
      FUNCTION INTR(x)
c        returnes the nearest to x integer value
c
      if(x.ge.0.) then
        j=x+0.5
      else
        j=x-0.5
      endif
      intr=j
      RETURN
      END
c
c****************************************************************
